/************************************************************
*
*  Copyright (c) 2002-2004 Jakub Schwarzmeier
*
************************************************************/

#ifndef GLOBALS_H
#define GLOBALS_H

#define WIN32_LEAN_AND_MEAN

//  use multithreading functions in header files

#ifdef __BORLANDC__ 
	#ifndef __MT__
		#define __MT__
	#endif
#endif

#ifdef _WIN32_IE
 #undef _WIN32_IE
 #define _WIN32_IE 0x0600
#endif

#define CRTDBG_MAP_ALLOC
#include <stdlib.h>
#include <crtdbg.h>

//  Windows SDK, STL, Standard C RTL headers

#include <windows.h>	//  base
#include <windowsx.h>	//  message crackers, API macros
#include <tchar.h>		//  unicode<->ansi, e.g. _itot, _tWinMain
#include <stdlib.h>		//  e.g. _itoa
#include <shlwapi.h>	//  IE4 common controls & new APIs
#pragma comment (lib, "shlwapi.lib")
#include <winsock2.h>
#pragma comment(lib, "ws2_32.lib")
#include <commctrl.h>	//  InitCommonControlsEx
#pragma comment(lib, "comctl32.lib")
#include <shellapi.h>

//  my headers

#include "resource.h"		//  main resource file
#include "../server.h"		//  server-specific functions
#include "../messages.h"	//  ui/cm/cm communication
#include "../winstring.h"	//  easier manipulation with TCHAR
#include "../misc.h"		//  miscellaneous
#include "bh_distrib.h"

#include "data/list.h"

#include <stdio.h>

//  Global variables
//

//  cannot initialize here, this is inserted into every file
extern HINSTANCE g_hInstance;
extern HWND g_hWnd;	
extern TCHAR szTitle[];
extern JakubSchwarzmeier::Data::RList< JakubSchwarzmeier::BarnesHut::Leave > * leavesList;
extern RemoteTree * remoteTree;
extern RequestsList * requestsList;
extern LocalTree * localTree;

extern SOCKET sListeningSocket;

extern HANDLE hContinueComputing;
extern HANDLE hSemNextComputation;

extern CRITICAL_SECTION csRequests;
extern CRITICAL_SECTION csAcceleration;
extern CRITICAL_SECTION csContinueComputing;

extern HANDLE evFillMessage;

extern long allDone;
extern long nRequests, nSatisfiedRequests;
extern long nOfReadyCMs;

extern double theta, epsilon, dt;

extern BYTE terminateSimulationID;
extern BYTE nCyclesToUISend;

bool ConnectLoop(DWORD dwUIIPAddress, BOOL loop = TRUE);

//  Prototypes

DWORD WINAPI ComputingThread( LPVOID lpParameter );
DWORD WINAPI IntegratingThread( LPVOID lpParameter );

// -------------------------------------------------------------------------
//  Dialog declarations
//

INT_PTR ShowIpAddressDlg( HWND, DWORD * );		//  defined in ipAddressDlg.cpp


#endif	//  GLOBALS_H

