/************************************************************
*
*  Copyright (c) 2002-2004 Jakub Schwarzmeier
*
************************************************************/

#include "general.h"

bool ConnectLoop(DWORD dwUIIPAddress, BOOL loop /*= TRUE*/)
{
	int connect_status;

	SOCKET sock = socket( PF_INET, SOCK_STREAM, IPPROTO_TCP );

	SOCKADDR_IN sockname;
	sockname.sin_family = AF_INET;
	sockname.sin_addr.S_un.S_addr = htonl(dwUIIPAddress);	//  UI IP address
	sockname.sin_port = htons(1981);

	//  connect to UI
	do
	{
		connect_status = connect( sock, (sockaddr*) &sockname, sizeof(sockname) );
		if (loop)  Sleep(2000);		//  try to reconnect after two seconds

	} while ( ( connect_status != 0 ) && ( loop ) );

	if ( connect_status == 0 )
	{
		//  connection to UI succesful

		//  add first client == UI
		Server->Clients.Add( new client( sockname.sin_addr.S_un.S_addr, sock ) );
		Server->Clients[0].ReadFile();	//  initiate reading from client (0 = UI)
	}

	return (!connect_status);
}


BOOL CALLBACK IPAddressDlgProc (HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);

	static DWORD * lpdwAddress;

	switch ( uMsg )
    {
    case WM_INITDIALOG:

		//  set initial IP address of IP control
		lpdwAddress =  (DWORD*)lParam;
		SendMessage( GetDlgItem( hDlg, IDC_IPADDRESS ), IPM_SETADDRESS, 0, (LPARAM)*lpdwAddress );

		return TRUE;

	case WM_COMMAND:

		switch ( LOWORD(wParam) )
		{
		case IDOK: 

			//  get IP address from IP control
			SendMessage( GetDlgItem( hDlg, IDC_IPADDRESS ), IPM_GETADDRESS, 0, (LPARAM)lpdwAddress );
			//  close dialog
			EndDialog( hDlg, IDOK );
			break;
		case IDCANCEL: 

			//  close dialog
			EndDialog( hDlg, IDCANCEL );
			break;
		}

		break; //  case WM_COMMAND

	}

	return FALSE;
}

INT_PTR ShowIpAddressDlg( HWND hWnd, DWORD * lpdwAddress )
{
	return DialogBoxParam( g_hInstance, TEXT("IpAddressDlg"), hWnd, IPAddressDlgProc, (LPARAM)lpdwAddress );
}