/************************************************************
*
*  Copyright (c) 2002-2004 Jakub Schwarzmeier
*
************************************************************/

#include "misc.h"

void MessageBox(int iNum)
{
	TCHAR szBuf[1024];
	_itot( iNum, szBuf, 10 );
	MessageBox( GetActiveWindow(), szBuf, NULL, MB_OK );
}

void MessageBox(LPCTSTR szText)
{
	GUITHREADINFO gui;
	gui.cbSize = sizeof(gui);
	GetGUIThreadInfo( GetCurrentThreadId(), &gui );

	TCHAR szTitle[MAX_PATH];
	GetWindowText( gui.hwndActive, szTitle, MAX_PATH );

	MessageBox( gui.hwndActive, szText, szTitle, MB_OK | MB_ICONINFORMATION);
}

void LoadString(HINSTANCE hInstance, WinString & string, int iResourceId)
{
	LoadString(hInstance, iResourceId, string.GetBuffer(), string.GetMaximumLength() );
}

//  function taken from MSDN
HRESULT GetShell32Version(LPDWORD pdwMajor, LPDWORD pdwMinor)
{
	HINSTANCE   hShell32;

	if(   IsBadWritePtr(pdwMajor, sizeof(DWORD)) || 
		IsBadWritePtr(pdwMinor, sizeof(DWORD)))
	return E_INVALIDARG;

	*pdwMajor = 0;
	*pdwMinor = 0;

	//  Load the DLL
	hShell32 = LoadLibrary(TEXT("shell32.dll"));

	if(hShell32)
	{
		HRESULT           hr = S_OK;
		DLLGETVERSIONPROC pDllGetVersion;
		   
		/*
		You must get this function explicitly because earlier versions of the DLL 
		don't implement this function. That makes the lack of implementation of the 
		function a version marker in itself.
		*/
		pDllGetVersion = (DLLGETVERSIONPROC)GetProcAddress(hShell32, "DllGetVersion");
		   
		if(pDllGetVersion)
			{
				DLLVERSIONINFO    dvi;
			      
				ZeroMemory(&dvi, sizeof(dvi));
				dvi.cbSize = sizeof(dvi);
			   
				hr = (*pDllGetVersion)(&dvi);
			      
				if(SUCCEEDED(hr))
					{
					*pdwMajor = dvi.dwMajorVersion;

					*pdwMinor = dvi.dwMinorVersion;
					}
			}
		else
			{
				/*
				If GetProcAddress failed, the DLL is a version previous to the one 
				shipped with IE 3.x.
				*/
				*pdwMajor = 4;
				*pdwMinor = 0;
			}
		   
		FreeLibrary(hShell32);

		return hr;
	}

	return E_FAIL;
}

void ShowLastError()
{
	LPVOID lpMessage;
	FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM, NULL, 
		GetLastError(), MAKELANGID( LANG_NEUTRAL, SUBLANG_DEFAULT ), (LPTSTR)&lpMessage, 0, NULL);
	MessageBox( GetActiveWindow(), (LPCTSTR)lpMessage, NULL, MB_OK | MB_ICONERROR | MB_SYSTEMMODAL );
	LocalFree( lpMessage );
}