/************************************************************
*
*  Copyright (c) 2002-2004 Jakub Schwarzmeier
*
************************************************************/

#ifndef SERVER_H
#define SERVER_H

//  avoid STL too long debug info warning
#pragma warning(disable:4786)

#include "Data\List.h"
#include <process.h>	//  C-runtime's _beginthreadex
#include "messages.h"	//  ui/cm/cm communication
#include <map>			//  for managing write buffers
#include <deque>		//  for managing incoming messages
#include <windows.h>	//  CRITICAL_SECTION

class server;
extern server * Server;

typedef unsigned (__stdcall *PTHREAD_START) (void *);

//  defined in UI and CM directories
DWORD WINAPI WorkerThread( LPVOID lpParameter );	//  prototype of non-OOP function

//  structure that contains info about every client
class client
{
public:

	client( int n_IPAddress, SOCKET s = 0 );
	~client();

	BOOL ReadFile();
	BOOL WriteFile( BYTE * lpBuffer, DWORD dwNumberOfBytesToWrite);
	BOOL ReadOperation( OVERLAPPED*, DWORD & );
	BOOL ReadOper(OVERLAPPED * ol);
	HANDLE SetSocket( SOCKET s );
	bool NextMessage();
	void getMessage( crackmessage & CrackMessage );

	HANDLE Socket;
	OVERLAPPED Overlapped;	//  for reading (single at time)
	LPVOID ReadBuffer;
	DWORD ReadBufferSize;
	LPVOID unfinishedBuffer;
	DWORD unfinishedUsedSize;
	CRITICAL_SECTION csWriteBuffers;
	typedef std::map<OVERLAPPED*, BYTE*> BUFFER;
	BUFFER * WriteBuffers;
	int IPAddress;

	std::deque< BYTE* >  mesBuf;
	std::deque< DWORD >  mesSize;
};

//  server oriented structure
class server
{
public:

	HANDLE hCompletionPort;		
	HANDLE hWorkerThread;		
	int IPAddress;
	HWND hWnd;
	BOOL bServiceTerminating;
	
	JakubSchwarzmeier::Data::RList<client> Clients;		//  list of all clients

	server();
	~server();

	void BindToWindow( HWND );
};

#endif