/************************************************************
*
*  Copyright (c) 2002-2004 Jakub Schwarzmeier
*
************************************************************/

#include "general.h"
#include "OpenGLView.h"

void OpenGLView::Render()
{
	
	//  clear the color and depth buffers 
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT); 

	//  simulate viewing transformation in ModelView matrix
	glLoadMatrixd( camera->GetMatrix() );

	glPointSize(2);
/*
	glBegin (GL_LINE_LOOP);
			 glVertex3f( -100, -100, -150 );
			 glVertex3f( 100, -100, -150 );
			 glVertex3f( 100, 100, -150 );
			 glVertex3f( -100, 100, -150 );
	glEnd();

	glBegin (GL_LINE_LOOP);
			 glVertex3f( -100, -100, 0 );
			 glVertex3f( 100, -100, 0 );
			 glVertex3f( 100, 100, 0 );
			 glVertex3f( -100, 100, 0 );
	glEnd();

	glBegin (GL_LINES);
			 glVertex3f( -100, 100, 0 );
			 glVertex3f( -100, 100, -150 );

			 glVertex3f( 100, 100, 0 );
			 glVertex3f( 100, 100, -150 );

			 glVertex3f( -100, -100, 0 );
			 glVertex3f( -100, -100, -150 );

			 glVertex3f( 100, -100, 0 );
			 glVertex3f( 100, -100, -150 );
	glEnd();
*/
	if (unsortedBodiesList==NULL) return;
	for( int i = 0; i < unsortedBodiesList->getCount(); i++ )
	{
		glPushMatrix();		//  push current viewing matrix

		//  model transformations
/*
		if ( unsortedBodiesList->getAt(i).mass == oneDiscBodyMass )		//  disc
		{
			if ( (rand() % 2) == 0 )	
				glColor3ub(255, 255, 255);		//  white
			else
				glColor3ub(109, 173, 252);		//  blue
		}
		else
		if ( unsortedBodiesList->getAt(i).mass == oneBulgeBodyMass )	glColor3ub(255, 255, 0);	//  bulge, yellow
		else
		glColor3ub(187, 17, 136);	//  halo, dark halo, violet

*/
		cols::iterator bufIter = colors.find( unsortedBodiesList->getAt(i).mass );
		std::deque<BYTE> deque = (*bufIter).second;
		glColor3ub(deque[0], deque[1], deque[2]);	

	glTranslated(
			unsortedBodiesList->getAt(i).position[0]*5,
			unsortedBodiesList->getAt(i).position[1]*5,
			unsortedBodiesList->getAt(i).position[2]*5
			);

		//  draw
		glBegin (GL_POINTS);
			 glVertex2f( 0, 0 );
		glEnd();


//	static GLUquadricObj * quadric = gluNewQuadric();

//	gluSphere( quadric, 0.3, 0, 0 );

		glPopMatrix();		//  pop back current viewing matrix
	}


	//  required
	glFinish();
}

void OpenGLView::InitializeMasses()
{
	colors.clear();

	for(int i = 0; i < unsortedBodiesList->GetCount(); i++)
	{
		std::deque<BYTE> deque;
		deque.push_back( ColorBytes[colors.size()][0] );
		deque.push_back( ColorBytes[colors.size()][1] );
		deque.push_back( ColorBytes[colors.size()][2] );
		colors.insert( cols::value_type(unsortedBodiesList->getAt(i).mass, deque) );	//  if this value is already in set, it reject it
	}
}

BYTE OpenGLView::ColorBytes[][3] = {
	{ 255, 255, 255 },		//  white
	{ 255, 255, 0 },		//  yellow
	{ 255, 0, 255 },			//  light violet
	{ 0, 255, 0 },
	{ 0, 255, 255 }
};

