/************************************************************
*
*  Copyright (c) 2002-2004 Jakub Schwarzmeier
*
************************************************************/

#include "general.h"


BOOL CALLBACK WaitForTerminateDlgProc (HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch ( uMsg )
	{
	case WM_INITDIALOG:

		if (!isSimulationRunning)
		{
			//  simulation is not running, immediately send terminating message

			if (terminateSimulationID > 1)
			{
				message terminatingMessage( sizeof(BYTE) );

				for(int i = 0; i < Server->Clients.getCount(); i++)
				{
					terminatingMessage.Initialize(CM_TERMINATE_SIMULATION);
					terminatingMessage.Add( terminateSimulationID );
					terminatingMessage.Finish();
					Server->Clients[i].WriteFile( terminatingMessage.GetBuffer(), terminatingMessage.GetBufferSize() );
				}
			}
			
			delete Server;
			Server = NULL;
			SendMessage(hDlg, WM_CLOSE, 0, 0);
		}

		return TRUE;
	
	case WM_CLOSE:

		if (isSimulationRunning == false)
		{
			EndDialog(hDlg, 0);
			MessageBox( TEXT("Simulace byla dokonena") );
		}

		return FALSE;

	}

	return FALSE;

}

BOOL CALLBACK TerminateSimulationDlgProc (HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch ( uMsg )
    {
    case WM_INITDIALOG: 
		{
		
		//  select one of radio buttons
		//
		HWND hWndChild = GetDlgItem(hDlg, IDC_TERMINATE_SIMULATION_WAIT_FOR_NEXT_SIMULATION);
		Button_SetCheck( hWndChild, BST_CHECKED );
		
		}

//		delete auxInfo;

		return TRUE;

	case WM_COMMAND:

		switch ( LOWORD(wParam) )
		{
		case IDOK:

			if ( IsDlgButtonChecked( hDlg, IDC_TERMINATE_SIMULATION_WAIT_FOR_NEXT_SIMULATION ) )  terminateSimulationID = 1;
			else
			if ( IsDlgButtonChecked( hDlg, IDC_TERMINATE_SIMULATION_QUIT_PROGRAM ) )  terminateSimulationID = 2;
			else
			if ( IsDlgButtonChecked( hDlg, IDC_TERMINATE_SIMULATION_LOGOUT_USER ) )  terminateSimulationID = 3;
			else
			terminateSimulationID = 4;

			EndDialog( hDlg, IDOK );

			break;

		case IDCANCEL:

			EndDialog( hDlg, IDCANCEL );

			break;

		}

		break; //  case WM_COMMAND
	}

	return FALSE;
}

INT_PTR ShowTerminateSimulationDlg( HWND hWnd )
{
	return DialogBox( Language.GetResourceInstance(), MAKEINTRESOURCE(IDD_TERMINATE_SIMULATION), hWnd, TerminateSimulationDlgProc );
}
