/************************************************************
*
*  Copyright (c) 2002-2004 Jakub Schwarzmeier
*
************************************************************/

#ifndef GLOBALS_H
#define GLOBALS_H

#define WIN32_LEAN_AND_MEAN

//  following used in Borland's includes (i think at least)
#ifdef __BORLANDC__ 
	#ifndef __MT__
		#define __MT__
	#endif
	#ifndef _MT
		#define _MT
	#endif
#endif

//  Windows SDK, STL, Standard C RTL headers

#define WINVER 0x0510

#include <windows.h>	//  base
#include <windowsx.h>	//  message crackers, API macros
#include <tchar.h>		//  unicode<->ansi, e.g. _itot, _tWinMain
#include <stdlib.h>		//  e.g. _itoa
#include <commdlg.h>	//  common dialogs (file save as)
#include <shlwapi.h>	//  IE4 common controls & new APIs
#pragma comment (lib, "shlwapi.lib")
#include <winsock2.h>
#pragma comment(lib, "ws2_32.lib")
#include <prsht.h>		//  property sheet common control, don't use header from VC6!
#pragma comment(lib, "comctl32.lib")	//  new common controls
#include <shlobj.h>		//  shell objects

//  my headers

#include "resource.h"		//  main resource file
#include "langs/lang_xx.h"	//  resource constants for localization
#include "lang.h"			//  localization work
#include "OpenGLView.h"
#include "../server.h"		//  server-specific functions
#include "../messages.h"	//  ui/cm/cm communication
#include "../winstring.h"	//  easier manipulation with TCHAR
#include "../misc.h"		//  miscellaneous

#include "data/list.h"
#include "barneshut/bh.h"

//  Global variables
//

//  cannot define here, this is inserted into every file
extern HINSTANCE g_hInstance;
extern HWND g_hWnd;	
extern TCHAR szTitle[SZ_LENGTH];
extern JakubSchwarzmeier::Data::RList< JakubSchwarzmeier::BarnesHut::Leave > * unsortedBodiesList;
extern int currentlyRecievedBody;
extern int nTotalBodies;
extern double oneDiscBodyMass;
extern double oneBulgeBodyMass;
extern double oneHaloBodyMass;
extern double oneDarkHaloBodyMass;
extern long nListenMachines;

extern BYTE terminateSimulationID;
extern BYTE nCyclesToResend;
extern bool isSimulationRunning;

extern double theta, epsilon, dt;

extern OpenGLView * openGL;		//  declared in ....

#define WM_UPDATE_VIEW  ( WM_APP + 1 ) 

#include "auxinfo.h"		//  auxiliary informations -- filenames, their handles
extern AuxInfo * auxInfo;

//  somewhere declared classes
class Lang;				//  declared in .....
extern Lang Language;		//  defined in ...

class DataFile;
extern DataFile * dataFile;		//  defined in main.cpp

void OrderAndSendData();			//  defined in RunSimulation.cpp
void LoadBodiesFromFile(TCHAR szFileName[], JakubSchwarzmeier::Data::RList< JakubSchwarzmeier::BarnesHut::Leave > & bodiesList );

// -------------------------------------------------------------------------
//  Dialog declarations
//

void ShowEstablishConnectionDlg (HWND);		//  defined in EstablishConnectionDlg.cpp
void ShowGalaxySimulationDlg (HWND);		//  defined in NewGalaxyDlg.cpp
void ShowEncounterSimulationDlg (HWND);		//  defined in EncounterDlg.cpp
void ShowOpenDlg (HWND);					//  defined in OpenDlg.cpp
INT_PTR ShowTerminateSimulationDlg( HWND );	//  defined in TerminateSimulationDlg.cpp
BOOL CALLBACK WaitForTerminateDlgProc (HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);	//  defined in TerminateSimulationDlg.cpp

#endif	//  GLOBALS_H

