/************************************************************
*
*  Copyright (c) 2002-2004 Jakub Schwarzmeier
*
************************************************************/

#include "lang.h"
#include <shlwapi.h>
#include "langs/lang_xx.h"	//  resource constants for localization
#include "../winstring.h"

Lang::Lang()
{
	TCHAR lpszLang[SZ_LENGTH];
	::GetLocaleInfo(LOCALE_USER_DEFAULT, LOCALE_SABBREVLANGNAME, lpszLang, sizeof lpszLang);

    TCHAR szLangFileName[MAX_PATH];
    ::GetModuleFileName (NULL, szLangFileName, sizeof(szLangFileName)/sizeof(TCHAR));
    ::PathRemoveFileSpec(szLangFileName);
	::lstrcat(szLangFileName, TEXT("\\lang_"));
	::lstrcat(szLangFileName, lpszLang);
	::lstrcat(szLangFileName, TEXT(".dll"));

	//  following does not work, i don't know reason
	//	hInstLangRes = ::LoadLibraryEx( szLangFileName, NULL, LOAD_LIBRARY_AS_DATAFILE );
	hInstLangRes = ::LoadLibraryEx( szLangFileName, NULL, DONT_RESOLVE_DLL_REFERENCES );

	buffer = new TCHAR[SZ_LENGTH+1];	//  include null terminating string
}

Lang::~Lang()
{
	::FreeLibrary( hInstLangRes );  
	delete [] buffer;
}

TCHAR * Lang::GetString(int iResourceId)
{
    ::LoadString(hInstLangRes, iResourceId, buffer, SZ_LENGTH);

	return buffer;
}

TCHAR * Lang::GetFileFilterString(int iResourceId)
{
    int len = ::LoadString(hInstLangRes, iResourceId, buffer, SZ_LENGTH);
	
	//  add closing zeros, ansi one zero, unicode two zeros
	int pos = (int)buffer + (len+1)*sizeof(TCHAR);
	TCHAR * mem = (TCHAR*) pos;
	int nZeros;
#if defined(_UNICODE) || defined(UNICODE)
	nZeros = 2;
#else
	nZeros = 1;
#endif
	ZeroMemory(mem, nZeros);		//  believe that my buffer have enough space

	return buffer;
}

TCHAR * Lang::GetBuffer()
{
	return buffer;
}


HMENU Lang::LoadMenu(int iResourceId)
{
	return ::LoadMenu(hInstLangRes, MAKEINTRESOURCE(iResourceId));
}

HINSTANCE Lang::GetResourceInstance()
{
	return hInstLangRes;
}


void Lang::ShowLastError( int iResource )
{	
	WinString errorMsg(512);
	errorMsg.AddToString( GetString(iResource) );
	errorMsg.AddToString( TEXT(": ") );
	errorMsg.AddToString( GetLastError() );

	MessageBox( GetActiveWindow(), errorMsg, NULL, MB_OK | MB_ICONSTOP );
}

