/************************************************************
*
*  Copyright (c) 2002-2004 Jakub Schwarzmeier
*
************************************************************/

#include "general.h"
#include "distribution.h"		//  struct Corner
#include <stdio.h>

double theta, epsilon, dt;

void OrderAndSendData()
{
	//  order bodies according to Hilbert curve
	//

	int i;
	JakubSchwarzmeier::Data::RList< JakubSchwarzmeier::BarnesHut::Leave > sortedBodiesList(unsortedBodiesList->getCount(), false);

	//  adaptive bisect -- find greatest value of spatial coordinate in absolut value
	double bisect = 0;
	for(i = 0; i < unsortedBodiesList->getCount(); i++)
	{
		for(int c = 0; c < 3; c++)
		{
			double val = fabs( unsortedBodiesList->getAt(i).position[c] );
			if ( val > bisect )  bisect = val;
		}

	}

	// increase by one (because of condition that compares corners of cube with values of particles)
	//  it must be farther then the furthest particle
	bisect++;

	Corner corner;
	
	for(i = 0; i < 3; i++)
	{
		corner.corner[i] = -bisect;
	}

//	FILE * f = fopen("D:\\runsim.dbg", "w");
//	fprintf(f, "pred %d\n", unsortedBodiesList->getCount() ); fflush(f);


	//  everything is prepared now, process Hilbert sort, startup recursion
	hilbertWalkThrough( *unsortedBodiesList, corner, bisect, &sortedBodiesList );

	//
	//  order bodies according to Hilbert curve

	//  distribute bodies between computing machines according to costzones (presented as load)
	//

	double totalLoad = 0;
	for(i = 0; i < sortedBodiesList.getCount(); i++)
	{
		totalLoad += sortedBodiesList.getAt(i).load;
	}

    //  tady muze dojit k chybe delenein nulou
    double LoadPerMachine;
    if (Server->Clients.getCount() != 0)
       LoadPerMachine = totalLoad / Server->Clients.getCount();

	double actualLoad = 0;
	int actualBody = 0;
	for(i = 0; i < Server->Clients.getCount(); i++)
	{
		//	needed ( ( 7*sizeof(double)*nBodiesForThisCM ) + 1 + 3*sizeof(double) ) Bytes for 1 message to i-th CM
		message SendMessage(6600001);		//  100.000 bodies to one CM
		SendMessage.Initialize( CM_INITIAL_DATA );

		SendMessage.Add(theta);
		SendMessage.Add(epsilon);
		SendMessage.Add(dt);

		SendMessage.Add((BYTE)5);

		while( ( actualLoad < LoadPerMachine ) && ( actualBody < sortedBodiesList.getCount() ) )
		{
			actualLoad += sortedBodiesList.getAt(actualBody).load;

			for(int j = 0; j < 3; j++)
			{
				SendMessage.Add( sortedBodiesList.getAt(actualBody).position[j] );
			}
			
			for(j = 0; j < 3; j++)
			{
				SendMessage.Add( sortedBodiesList.getAt(actualBody).velocity[j] );
			}
			
			SendMessage.Add( sortedBodiesList.getAt(actualBody).mass );

			actualBody++;
		}
		
		SendMessage.Finish();

 		Server->Clients[i].WriteFile( SendMessage.GetBuffer(), SendMessage.GetBufferSize() );
		actualLoad = 0;
	}

	nTotalBodies = sortedBodiesList.getCount();		//  tohle je pekna sasrkarna, nekdy to pred hazelo 1000 a za 999

//	fprintf(f, "za %d\n", sortedBodiesList.getCount() ); fflush(f);
//	fclose(f);

	//
	//  distribution between computing machines according to costzones (presented as load)
}

