#ifndef OPENGL_H
#define OPENGL_H

#include <windows.h>
#include <windowsx.h>
#include <gl/gl.h>
#include <gl/glu.h>

#pragma comment (lib, "opengl32.lib")
#pragma comment (lib, "glu32.lib")

#include "opengl/camera.h"

using namespace JakubSchwarzmeier::OpenGL;

namespace JakubSchwarzmeier
{
	
	namespace Windows
	{

		class OpenGL
		{
		public:
			OpenGL(HWND n_hWnd = NULL);		//  when deriving classes, compiler needs impicit constructor in base class
			~OpenGL();

			void OnSize(int & cx, int & cy);
			virtual void Render();
			void OnPaint (HDC hDC);
			void DisableDrawing();
			void SetCamera( Camera * n_camera );
			HBITMAP GetDibSection();
			HDC GetDC();

		protected:
			bool active;
			bool fullscreen;
			int width, height;
			Camera * camera;

			HWND hWnd;
			HGLRC hRC;
			HDC hMemDC;
			void* m_pBits;
			BITMAPINFOHEADER BIH;
			HBITMAP hbmOld;
			HBITMAP hDibSection;

			void Resize(int n_width, int n_height);

		};

	}	//  end namespace Windows

}	//  end namespace JakubSchwarzmeier

#endif // OPENGL_H