#include "xml.h"

void main()
{
	using namespace JakubSchwarzmeier::Data;

	XmlDocument xmlDoc;

	XmlProcessingInstruction pi;
	pi = xmlDoc.CreateProcessingInstruction(TEXT("xml"), TEXT("version='1.0'"));
	xmlDoc.AppendChild( pi );
	
	XmlElement root = xmlDoc.CreateElement(TEXT("simulation"));
	xmlDoc.AppendChild( root );
	root.SetAttribute(TEXT("type"), TEXT("single"));

	XmlElement element;
	XmlText text;
	
	element = xmlDoc.CreateElement(TEXT("count"));
	text = xmlDoc.CreateTextNode(TEXT("5.625"));
	element.AppendChild( text );
	root.AppendChild( element );
	
	element = xmlDoc.CreateElement(TEXT("format"));
	text = xmlDoc.CreateTextNode(TEXT("double"));
	element.AppendChild( text );
	root.AppendChild( element );

	element = xmlDoc.CreateElement(TEXT("description"));
	text = xmlDoc.CreateTextNode(TEXT("This is a very nice simulation."));
	element.AppendChild( text );
	root.AppendChild( element );

	XmlElement parameters = xmlDoc.CreateElement(TEXT("parameters"));
	root.AppendChild( parameters );

	XmlElement components = xmlDoc.CreateElement(TEXT("components"));
	parameters.AppendChild( components );
	
	element = xmlDoc.CreateElement(TEXT("disc"));
	text = xmlDoc.CreateTextNode(TEXT("Disk"));
	element.AppendChild( text );
	components.AppendChild( element );
	
	element = xmlDoc.CreateElement(TEXT("bulge"));
	text = xmlDoc.CreateTextNode(TEXT("Bulga"));
	element.AppendChild( text );
	components.AppendChild( element );

	element = xmlDoc.CreateElement(TEXT("halo"));
	text = xmlDoc.CreateTextNode(TEXT("Halooo"));
	element.AppendChild( text );
	components.AppendChild( element );

	xmlDoc.DoHumanMarkup( root );
	xmlDoc.Save(TEXT("D:\\sample.xml"));
	
}