#ifndef MATH_EXT_H
#define MATH_EXT_H

#include <math.h>
#include <stdlib.h>	//  srand
#include <windows.h>	//  required for TCHAR
#include <tchar.h>
#include <stdio.h>

//************************************************************
//
// Some non-OOP math hairy stuff
//
// 



// some math.h (like VC++) doesn't have PI defined (BC++ does)
#ifndef M_PI
const long double M_PI = 3.14159265358979323846; 
#endif

long double sin_angle(const long double angle);

long double cos_angle(const long double angle);

long double tan_angle(const long double angle);

long double asin_angle(const double x);

long double acos_angle(const double x);

long double atan_angle(const double x);

long double atan2_angle(const double y, const double x);

double random(long idum = 1);	//  from Numerical Recipes in C

TCHAR * _dtot(double value, TCHAR * string);	//  conversion routine double --> string

//  Borland and Microsoft don't settle with universal unicode/ansi names
//  string --> double conversion routine: _tstof

#ifdef UNICODE
	#if (_MSC_VER == 1200)
	double _tstof(const WCHAR szValue[]);
	#else
    #define _tstof _wtof		//  declared in stdlib.h
	#endif
#else
  //  ANSI
  #define _tstof atof
#endif

double TrapezoidalIntegration(	double (*func)(double), double lower, double upper, int steps );

double FindMaximum( double (*f)(double), double L, double U, double tol);

//  Error and Zeta Functions
/*
The error and Riemann zeta functions frequently occur in probability and statistics problems.

ERF(z) is the integral of the Gaussian distribution from 0 to z.  
*/
double erf( double q );

#endif // MATH_EXT_H