/************************************************************
*
*  Copyright (c) 2002-2004 Jakub Schwarzmeier
*
************************************************************/

#ifndef DISTRIBUTION_BULGE_H
#define DISTRIBUTION_BULGE_H

#include "data\list.h"
#include "BarnesHut\bh.h"

class BulgeModel
{
public:

	static void Initialize(double n_totalMass, double n_rbmax, double n_ab);
	static bool Create(JakubSchwarzmeier::Data::RList< JakubSchwarzmeier::BarnesHut::Leave > & list, const int & nBodies);

private:

	static double rDistribution(double r);
	static double vCurve(double r);
	static double plummer( double r );

	static double totalMass;

	static double rbmax;
	static double ab;
};


#endif	//  DISTRIBUTION_BULGE_H