/************************************************************
*
*  Copyright (c) 2002-2004 Jakub Schwarzmeier
*
************************************************************/

#ifndef DISTRIBUTION_DARKHALO_H
#define DISTRIBUTION_DARKHALO_H

#include "data\list.h"
#include "BarnesHut\bh.h"

class DarkHaloModel
{
public:

	static void Initialize(double n_totalMass, double n_rdhmax, double n_adh, double n_gamma);
	static bool Create(JakubSchwarzmeier::Data::RList< JakubSchwarzmeier::BarnesHut::Leave > & list, const int & nBodies);

private:

	static double rDistribution(double r);
	static double vCurve(double r);

	static double totalMass;

	static double rdhmax;
	static double adh;
	static double gamma;
};

#endif	//  DISTRIBUTION_DARKHALO_H