/************************************************************
*
*  Copyright (c) 2002-2004 Jakub Schwarzmeier
*
************************************************************/

#ifndef DISTRIBUTION_DISK_H
#define DISTRIBUTION_DISK_H

#include "data\list.h"
#include "BarnesHut\bh.h"

class DiskModel
{
public:

	enum RADIAL_DISTRIBUTION { Model1, Model2 };
	enum Z_DISTRIBUTION { MyZDistr1 };
	enum VELOCITY_CURVE { Toomre, Flat };

 	static void Initialize(double n_totalMass, double n_rdmax, double n_ad, double n_z0, double n_toomreQ, double n_zVelocityDisp, enum RADIAL_DISTRIBUTION n_rDistribution, enum Z_DISTRIBUTION n_zDistribution = MyZDistr1, enum VELOCITY_CURVE n_vCurve = Toomre);
	static bool Create(JakubSchwarzmeier::Data::RList< JakubSchwarzmeier::BarnesHut::Leave > & list, const int & nBodies);

private:

	static double model1( double r );
	static double model2( double r );
	static double zdistr1( double r );

	static double toomre( double r );
	static double flat( double r );

	static double totalMass;

	static double rdmax;
	static double ad;
	static double z0;
	static double toomreQ;
	static double zVelocityDisp;
	static double zignored;

	static RADIAL_DISTRIBUTION rDistribution;
	static Z_DISTRIBUTION zDistribution;
	static VELOCITY_CURVE vCurve;

	static double r;
};


#endif	//  DISTRIBUTION_DISK_H