#pragma once

#ifndef _AFXEXT
	#ifdef _UNICODE
		#ifdef _DEBUG
			#pragma comment(lib, "MFC.Net_debug-unicode.lib")
		#else
			#pragma comment(lib, "MFC.Net_release-unicode.lib")
		#endif
	#else
		#ifdef _DEBUG
			#pragma comment(lib, "MFC.Net_debug-ansi.lib")
		#else
			#pragma comment(lib, "MFC.Net_release-ansi.lib")
		#endif
	#endif
#endif


namespace JakubSchwarzmeier
{
	namespace MFC
	{
		namespace Net
		{
			//  Initialize this namespace
			
			static class Net
			{
			public:
				Net()
				{
					//  initialize WinSock 2.2
					WSADATA wsadata;
					int i = WSAStartup( MAKEWORD( 2, 2 ), &wsadata );
					if (i != 0)
					{
						JakubSchwarzmeier::MFC::System::ErrorMessageBox( TEXT(__FILE__), __LINE__ );
						throw;
					}
				}

				~Net()
				{
					//  deinitialize WinSock
					WSACleanup();
				}

			} net;

			AFX_EXT_CLASS CString GetLocalName();
			AFX_EXT_CLASS CString GetLocalAddress();

			namespace Sockets
			{
				class IProtocol;
				class CSocket;
				class CSocketPool;
			}
		}
	}
}

#include "../src/mfc/net/socket.h"
#include "../src/mfc/net/socketpool.h"
#include "../src/mfc/net/iprotocol.h"
#include "../src/mfc/net/winsockexception.h"

#include "../src/mfc/net/httparchetype.h"
#include "../src/mfc/net/httprequest.h"
#include "../src/mfc/net/httpresponse.h"
#include "../src/mfc/net/httpprocessor.h"
