#pragma once

//  This file MUST be included in every JakubSchwarzmeier namespace program.

#ifndef _AFXEXT
	#ifdef _UNICODE
		#ifdef _DEBUG
			#pragma comment(lib, "SFC.System_debug.lib")
		#else
			#pragma comment(lib, "SFC.System_release.lib")
		#endif
	#else
		#pragma message( "SFC: Only for unicode builds." )
	#endif
#endif

namespace JakubSchwarzmeier
{
	namespace SFC
	{
		namespace System
		{
			//  Globalization: function prototypes
			AFX_EXT_CLASS void LoadResourceDll( AFX_EXTENSION_MODULE & extModule );
			AFX_EXT_CLASS void FreeResourceDll( AFX_EXTENSION_MODULE & extModule );

			//  Initialize this namespace
			
			static class System
			{
			public:

				System()
				{
				}

				~System()
				{
				}

			} system;
			
			//  Display error message before localized resources are loaded.
			AFX_EXT_CLASS void ErrorMessageBox( TCHAR szFile[], long lLine );

			class CStringHashTraits: public CElementTraits<CString>
			{
			public:
				static ULONG Hash( const CString & string ) throw()
				{
					LPCTSTR key = (LPCTSTR) string;
					UINT nHash = 0;
					while (*key)
						nHash = (nHash<<5) + nHash + *key++;
					return nHash;
				}
			};

			class CStringAHashTraits: public CElementTraits<CStringA>
			{
			public:
				static ULONG Hash( const CStringA & string ) throw()
				{
					LPCSTR key = (LPCSTR) string;
					UINT nHash = 0;
					while (*key)
						nHash = (nHash<<5) + nHash + *key++;
					return nHash;
				}
			};

			namespace IO
			{
				class IIOCPStream;
			}
		}
	}
}

#include "../src/sfc/system/except.h"
#include "../src/sfc/system/completionport.h"
#include "../src/sfc/system/iocpstream.h"
#include "../src/sfc/system/buffer.h"

typedef JakubSchwarzmeier::SFC::System::CBaseException CBaseException; 
typedef JakubSchwarzmeier::SFC::System::CComException CComException;
typedef JakubSchwarzmeier::SFC::System::CWindowsException CWindowsException;

typedef JakubSchwarzmeier::SFC::System::CStringHashTraits CStringHashTraits;
typedef JakubSchwarzmeier::SFC::System::CStringAHashTraits CStringAHashTraits;
