#ifndef __EXCEL__
#define __EXCEL__

#ifdef WIN32
	#ifndef _LIB
		#ifdef _DEBUG
			#pragma comment(lib, "util-debug.lib")
		#else
			#pragma comment(lib, "util-release.lib")
		#endif
	#endif
#endif

// Exclude rarely-used stuff from Windows headers
#define WIN32_LEAN_AND_MEAN		

//  MS C-RTL
#include <tchar.h>

//  EXCEL COM
//  #import "libid:{00020813-0000-0000-C000-000000000046}" auto_search auto_rename version(1.3) lcid(0) no_search_namespace
#include "../../ext/comexcel/excel.tlh"

//  Standard Template Library
#include <string>

#include "comutil.h"

void dump_com_error(_com_error &e);

Excel::_ApplicationPtr CreateExcel();
void QuitExcel(Excel::_ApplicationPtr pExcel);
Excel::_WorkbookPtr AddWorkbook(Excel::_ApplicationPtr pExcel);
void SetCellValue(Excel::_WorksheetPtr pWorksheet, int col, int row, std::string value);
void SetCellValue(Excel::_WorksheetPtr pWorksheet, int col, int row, double value);
std::string GetCellValue(Excel::_WorksheetPtr pWorksheet, size_t col, size_t row);

Excel::_ChartPtr CreateChart( Excel::_WorkbookPtr pWorkbook, Excel::_WorksheetPtr pWorksheet,
		std::string chartTitle, std::string xlabel, std::string ylabel );

void SetSeriesValues( Excel::SeriesPtr series, Excel::_WorksheetPtr pSheet, 
					 size_t xColStart, size_t xRowStart, size_t xColEnd, size_t xRowEnd, 
					 size_t yColStart, size_t yRowStart, size_t yColEnd, size_t yRowEnd );

Excel::RangePtr GetRange( Excel::_WorksheetPtr pSheet, size_t columnStart, size_t rowStart, size_t columnEnd, size_t rowEnd );


#endif // __EXCEL__