#ifndef __XMLLIB__
#define __XMLLIB__

#ifdef WIN32
	#ifndef _LIB
		#ifdef _DEBUG
			#pragma comment(lib, "util-debug.lib")
		#else
			#pragma comment(lib, "util-release.lib")
		#endif
	#endif
#endif

//  Standard Template Library
#include <string>

//  LIBXML
#include <libxml/xmlmemory.h>
#include <libxml/parser.h>
#include <libxml/xpath.h>

//  C-RTL
#include <tchar.h>

#include <schwarzmeier/std.h>

std::string GetXPathResponse( xmlDoc * pXmlDoc, xmlNode * pNode, std::string strXPath );
xmlNode * SelectSingleNode( xmlDoc * pXmlDoc, xmlNode * pNode, std::string strXPath );
xmlNodeSet * SelectNodes( xmlDoc * pXmlDoc, xmlNode * pNode, std::string strXPath );
void SetAttribute( xmlNode * pNode, std::string attName, double attValue );
void SetAttribute( xmlNode * pNode, std::string attName, int attValue );
void SetAttribute( xmlNode * pNode, std::string attName, bool attValue );
void SetTextNode( xmlDoc * pXmlDoc, xmlNode * pNode, std::string textValue );
void SetTextNode( xmlDoc * pXmlDoc, xmlNode * pNode, int textValue );
void SetTextNode( xmlDoc * pXmlDoc, xmlNode * pNode, double textValue );
void SetTextNode( xmlDoc * pXmlDoc, xmlNode * pNode, JakubSchwarzmeier::Std::Math::Matrix<> & matrix );
void SetTextNode( xmlDoc * pXmlDoc, xmlNode * pNode, JakubSchwarzmeier::Std::Math::Quaternion<> & q );
void SetTextNode( xmlDoc * pXmlDoc, xmlNode * pNode, JakubSchwarzmeier::Std::Math::Vector<> & v );
void GetAttribute( xmlNode * pNode, std::string attName, double * retValue );
void GetAttribute( xmlNode * pNode, std::string attName, int * retValue );
void GetAttribute( xmlNode * pNode, std::string attName, bool * retValue );
void GetTextNode( xmlDoc * pXmlDoc, xmlNode * pNode, JakubSchwarzmeier::Std::Math::Matrix<> * matrix );
void GetTextNode( xmlDoc * pXmlDoc, xmlNode * pNode, JakubSchwarzmeier::Std::Math::Quaternion<> * q );
void GetTextNode( xmlDoc * pXmlDoc, xmlNode * pNode, JakubSchwarzmeier::Std::Math::Vector<> * v );

#endif //  __XMLLIB__
