#ifndef _NOSTRADAMUS_DATETIME_H_
#define _NOSTRADAMUS_DATETIME_H_

#include <wx/datetime.h>
#include <unicode/gregocal.h>
#include "../stdafx.h"

namespace JakubSchwarzmeier
{
	namespace Astronomy
	{
		class CDateTime: public wxDateTime
		{
		public:
			CDateTime();
			CDateTime(GregorianCalendar * gc);
			CDateTime( const wxDateTime & wxDT);
			CDateTime( const CDateTime & original );
			CDateTime( double jdn );
			virtual ~CDateTime(void);

			CDateTime & operator=( const CDateTime & right_side );

			bool SetMonthInt(int month);
			int GetMonthInt();

			//  same as FormateDate, but ensure, that year part is 4-digits wide
			wxString FormatDateLong();
			static wxChar GetDateSeparator();
			
			//  hh:mm:ss 24-hour time format with program's locale separators
			wxString FormatTimeLong();
			static wxChar GetTimeSeparator();

			void Serialize(xmlDoc * pXmlDoc, xmlNode * branch);
			void Deserialize(xmlDoc * pXmlDoc, xmlNode * pXmlNode);

		protected:

			static std::string s_strDateTime;
		};

	}	//  namespace Astronomy

} // namespace JakubSchwarzmeier

#endif	//  _NOSTRADAMUS_DATETIME_H_
