/************************************************************
*
*  Copyright (c) 2006 Jakub Schwarzmeier
*
************************************************************/

#ifndef _WX_VALTIME_H_
#define _WX_VALTIME_H_

#include <wx/validate.h>
#include "datetime.h"

class wxTimeValidator: public wxValidator
{
DECLARE_DYNAMIC_CLASS(wxTimeValidator)
public:
	wxTimeValidator(JakubSchwarzmeier::Astronomy::CDateTime * val = NULL);
	wxTimeValidator(const wxTimeValidator& copyFrom);

    // Make a clone of this validator (or return NULL) - currently necessary
    // if you're passing a reference to a validator.
    // Another possibility is to always pass a pointer to a new validator
    // (so the calling code can use a copy constructor of the relevant class).
    virtual wxObject *Clone() const { return new wxTimeValidator(*this); }
	bool Copy(const wxTimeValidator& val);

    // Called when the value in the window must be validated.
    // This function can pop up an error message.
    virtual bool Validate(wxWindow *parent);

    // Called to transfer data to the window
    virtual bool TransferToWindow();

    // Called to transfer data to the window
    virtual bool TransferFromWindow();

protected:

	bool ScanfHourMinuteSecond(wxString val, int * hour, int * minute, int * second);

	JakubSchwarzmeier::Astronomy::CDateTime * m_pVal;
};

#endif // _WX_VALTIME_H_