#include "stdafx.h"

#include "ObserverPageDlg.h"
#include <std.h>
#include ".\observerpagedlg.h"

using namespace JakubSchwarzmeier::Std;

extern AFX_EXTENSION_MODULE SFCGraphicsDLL;

// CCometPropertyPage dialog

IMPLEMENT_DYNAMIC(CObserverPageDlg, CPropertyPage)
CObserverPageDlg::CObserverPageDlg(JakubSchwarzmeier::SFC::Graphics::CObserver * observer)
	: CPropertyPage(CObserverPageDlg::IDD)
	, m_positionStep(0)
	, m_angleStep(0)
{
	ASSERT_VALID( observer );
	m_pObserver = observer;
	m_psp.hInstance = SFCGraphicsDLL.hResource;
}

CObserverPageDlg::~CObserverPageDlg()
{
}

void CObserverPageDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_POSITION_STEP, m_positionStep);
	DDX_Text(pDX, IDC_ANGLE_STEP, m_angleStep);
}

BEGIN_MESSAGE_MAP(CObserverPageDlg, CPropertyPage)
	ON_BN_CLICKED(IDC_ARROW_LEFT, OnBnClickedArrowLeft)
	ON_BN_CLICKED(IDC_ARROW_RIGHT, OnBnClickedArrowRight)
	ON_BN_CLICKED(IDC_ARROW_UP, OnBnClickedArrowUp)
	ON_BN_CLICKED(IDC_ARROW_DOWN, OnBnClickedArrowDown)
	ON_BN_CLICKED(IDC_HEADING_LEFT, OnBnClickedHeadingLeft)
	ON_BN_CLICKED(IDC_HEADING_RIGHT, OnBnClickedHeadingRight)
	ON_BN_CLICKED(IDC_PITCH_UP, OnBnClickedPitchUp)
	ON_BN_CLICKED(IDC_PITCH_DOWN, OnBnClickedPitchDown)
	ON_BN_CLICKED(IDC_ROLL_CCW, OnBnClickedRollCcw)
	ON_BN_CLICKED(IDC_ROLL_CW, OnBnClickedRollCw)
	ON_EN_UPDATE(IDC_POSITION_STEP, OnEnUpdatePositionStep)
	ON_EN_UPDATE(IDC_ANGLE_STEP, OnEnUpdateAngleStep)
	ON_BN_CLICKED(IDC_ARROW_LEFT_DOWN, OnBnClickedArrowLeftDown)
	ON_BN_CLICKED(IDC_ARROW_RIGHT_UP, OnBnClickedArrowRightUp)
END_MESSAGE_MAP()

BOOL CObserverPageDlg::OnInitDialog()
{
	if (!__super::OnInitDialog())  return FALSE;	//  triggers DDX values --> dialog

	m_positionStep = m_pObserver->GetStepSize().position;
	m_angleStep = m_pObserver->GetStepSize().angle;
	UpdateData(FALSE);	//  variables --> dialog

	//  Direction
	::SendMessage(::GetDlgItem(m_hWnd, IDC_ARROW_UP), BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)::LoadBitmap(SFCGraphicsDLL.hModule, MAKEINTRESOURCE(IDB_ARROW_UP)));
	::SendMessage(::GetDlgItem(m_hWnd, IDC_ARROW_DOWN), BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)::LoadBitmap(SFCGraphicsDLL.hModule, MAKEINTRESOURCE(IDB_ARROW_DOWN)));
	::SendMessage(::GetDlgItem(m_hWnd, IDC_ARROW_LEFT), BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)::LoadBitmap(SFCGraphicsDLL.hModule, MAKEINTRESOURCE(IDB_ARROW_LEFT)));
	::SendMessage(::GetDlgItem(m_hWnd, IDC_ARROW_RIGHT), BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)::LoadBitmap(SFCGraphicsDLL.hModule, MAKEINTRESOURCE(IDB_ARROW_RIGHT)));
	::SendMessage(::GetDlgItem(m_hWnd, IDC_ARROW_LEFT_DOWN), BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)::LoadBitmap(SFCGraphicsDLL.hModule, MAKEINTRESOURCE(IDB_ARROW_LEFT_DOWN)));
	::SendMessage(::GetDlgItem(m_hWnd, IDC_ARROW_RIGHT_UP), BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)::LoadBitmap(SFCGraphicsDLL.hModule, MAKEINTRESOURCE(IDB_ARROW_RIGHT_UP)));

	//  Heading
	::SendMessage(::GetDlgItem(m_hWnd, IDC_HEADING_LEFT), BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)::LoadBitmap(SFCGraphicsDLL.hModule, MAKEINTRESOURCE(IDB_ARROW_LEFT)));
	::SendMessage(::GetDlgItem(m_hWnd, IDC_HEADING_RIGHT), BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)::LoadBitmap(SFCGraphicsDLL.hModule, MAKEINTRESOURCE(IDB_ARROW_RIGHT)));

	//  Pitch
	::SendMessage(::GetDlgItem(m_hWnd, IDC_PITCH_UP), BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)::LoadBitmap(SFCGraphicsDLL.hModule, MAKEINTRESOURCE(IDB_ARROW_UP)));
	::SendMessage(::GetDlgItem(m_hWnd, IDC_PITCH_DOWN), BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)::LoadBitmap(SFCGraphicsDLL.hModule, MAKEINTRESOURCE(IDB_ARROW_DOWN)));

	//  Roll
	::SendMessage(::GetDlgItem(m_hWnd, IDC_ROLL_CCW), BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)::LoadBitmap(SFCGraphicsDLL.hModule, MAKEINTRESOURCE(IDB_ARROW_CCW)));
	::SendMessage(::GetDlgItem(m_hWnd, IDC_ROLL_CW), BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)::LoadBitmap(SFCGraphicsDLL.hModule, MAKEINTRESOURCE(IDB_ARROW_CW)));

	return TRUE;
}

void CObserverPageDlg::OnOK()
{
	UpdateData();		//  DDX dialog --> values
	CPropertyPage::OnOK();
}

void CObserverPageDlg::OnBnClickedArrowLeft()
{
	m_pObserver->ChangePosition( Vector<>(-m_pObserver->GetStepSize().position, 0, 0) );
	m_pObserver->m_view->ReleaseRenderingThread();
}

void CObserverPageDlg::OnBnClickedArrowRight()
{
	m_pObserver->ChangePosition( Vector<>(m_pObserver->GetStepSize().position, 0, 0) );
	m_pObserver->m_view->ReleaseRenderingThread();
}

void CObserverPageDlg::OnBnClickedArrowUp()
{
	m_pObserver->ChangePosition( Vector<>(0, -m_pObserver->GetStepSize().position, 0) );
	m_pObserver->m_view->ReleaseRenderingThread();
}

void CObserverPageDlg::OnBnClickedArrowDown()
{
	m_pObserver->ChangePosition( Vector<>(0, m_pObserver->GetStepSize().position, 0) );
	m_pObserver->m_view->ReleaseRenderingThread();
}

void CObserverPageDlg::OnBnClickedArrowLeftDown()
{
	m_pObserver->ChangePosition( Vector<>(0, 0, m_pObserver->GetStepSize().position) );
	m_pObserver->m_view->ReleaseRenderingThread();
}

void CObserverPageDlg::OnBnClickedArrowRightUp()
{
	m_pObserver->ChangePosition( Vector<>(0, 0, -m_pObserver->GetStepSize().position) );
	m_pObserver->m_view->ReleaseRenderingThread();
}

void CObserverPageDlg::OnBnClickedHeadingLeft()
{
	m_pObserver->ChangeHeading( m_pObserver->GetStepSize().angle );
	m_pObserver->m_view->ReleaseRenderingThread();
}

void CObserverPageDlg::OnBnClickedHeadingRight()
{
	m_pObserver->ChangeHeading( -m_pObserver->GetStepSize().angle );
	m_pObserver->m_view->ReleaseRenderingThread();
}

void CObserverPageDlg::OnBnClickedPitchUp()
{
	m_pObserver->ChangePitch( m_pObserver->GetStepSize().angle );
	m_pObserver->m_view->ReleaseRenderingThread();
}

void CObserverPageDlg::OnBnClickedPitchDown()
{
	m_pObserver->ChangePitch( -m_pObserver->GetStepSize().angle );
	m_pObserver->m_view->ReleaseRenderingThread();
}

void CObserverPageDlg::OnBnClickedRollCcw()
{
	m_pObserver->ChangeRoll( m_pObserver->GetStepSize().angle );
	m_pObserver->m_view->ReleaseRenderingThread();
}

void CObserverPageDlg::OnBnClickedRollCw()
{
	m_pObserver->ChangeRoll( -m_pObserver->GetStepSize().angle );
	m_pObserver->m_view->ReleaseRenderingThread();
}


void CObserverPageDlg::OnEnUpdatePositionStep()
{
	UpdateData(TRUE);	//  dialog --> variables		//  triggers data exchange/validation
	m_pObserver->SetPositionStepSize(m_positionStep);
}

void CObserverPageDlg::OnEnUpdateAngleStep()
{
	UpdateData(TRUE);	//  dialog --> variables		//  triggers data exchange/validation
	m_pObserver->SetAngleStepSize(m_angleStep);
}

