#include "stdafx.h"

#include <string.h>

#include "OpenGLStateDlg.h"
#include <SFC.Graphics.h>

using namespace JakubSchwarzmeier::SFC::Graphics;

// COpenGLStateDlg dialog

IMPLEMENT_DYNAMIC(COpenGLStateDlg, CDialog)
COpenGLStateDlg::COpenGLStateDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COpenGLStateDlg::IDD, pParent)
{
}

COpenGLStateDlg::~COpenGLStateDlg()
{
}

/*virtual*/BOOL COpenGLStateDlg::OnInitDialog()
{
	if ( !__super::OnInitDialog() )  return FALSE;

	COpenGLView * glWnd = reinterpret_cast<COpenGLView*>(m_pParentWnd);

	BOOL success;
	HDC hDC;
	if (glWnd->m_bConstBitmap)	 hDC = glWnd->m_hDcPBuffer;
	else
		hDC = glWnd->m_hDcView;

	success = wglMakeCurrent( hDC, glWnd->m_hRC );
	if (success != TRUE)
	{
		THROW_WINDOWS_EXCEPTION()
	}

	char gfx_text[4096];
	CString strGFX;

	strcpy(gfx_text, (char*)glGetString(GL_VENDOR)); 
	strGFX.Format( TEXT("Vendor: %s"), CString(gfx_text) );
	m_listBox.AddString( strGFX );
	
	strcpy(gfx_text, (char*)glGetString(GL_RENDERER)); 
	strGFX.Format( TEXT("Renderer: %s"), CString(gfx_text) );
	m_listBox.AddString( strGFX );

	strcpy(gfx_text, (char*)glGetString(GL_VERSION)); 
	strGFX.Format( TEXT("Version: %s"), CString(gfx_text) );
	m_listBox.AddString( strGFX );

	strcpy(gfx_text, (char*)glGetString(GL_EXTENSIONS)); 
	strGFX.Format( TEXT("Extensions: %s"), CString(gfx_text) );
	m_listBox.AddString( strGFX );

	wglMakeCurrent( NULL, NULL );

	return TRUE;
}

void COpenGLStateDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_OPENGLINFO, m_listBox);
}


BEGIN_MESSAGE_MAP(COpenGLStateDlg, CDialog)
END_MESSAGE_MAP()


// COpenGLStateDlg message handlers
