/************************************************************
*
*  Copyright (c) 2002-2004 Jakub Schwarzmeier
*
************************************************************/

#pragma once

class CObserverPageDlg;

namespace JakubSchwarzmeier {

	namespace SFC {

		namespace Graphics {

			class AFX_EXT_CLASS CObserver: 
				public JakubSchwarzmeier::Std::Graphics::Camera,
				public CObject
			{
			public:
				
				CObserver();
				~CObserver();
				virtual void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
				virtual void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
				virtual void OnRButtonDown(UINT nFlags, int x, int y);
				virtual void OnRButtonUp(UINT nFlags, int x, int y);
				virtual void OnMouseMove(UINT nFlags, int x, int y);

				void SetView( COpenGLView * view );
				CPropertyPage * GetSettingsPage();

				struct STEP_SIZE {

					double position; double angle;
				};

				void SetPositionStepSize(double stepSize);
				void SetAngleStepSize(double stepSize);
				STEP_SIZE GetStepSize();

			protected:

				void UpdateInputs();

				bool m_keys[0xFF];
				STEP_SIZE m_stepSize;

				bool m_bMouseRightDrag;
				POINT m_posRMouse;

				COpenGLView * m_view;
				::CObserverPageDlg * m_dlgSettings;
				friend ::CObserverPageDlg;
			
			};	//  end class CObserver

		}	//  end namespace Graphics

	}	//  end namespace OpenGL

}	//  end namespace JakubSchwarzmeier