// MFC.Net.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include <MFC.Net.h>

#include <afxdllx.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

static AFX_EXTENSION_MODULE MFCNetDLL = { NULL, NULL };

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	// Remove this if you use lpReserved
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("MFCNet.DLL Initializing!\n");
		
		// Extension DLL one-time initialization
		if (!AfxInitExtensionModule(MFCNetDLL, hInstance))
			return 0;

		// Insert this DLL into the resource chain
		// NOTE: If this Extension DLL is being implicitly linked to by
		//  an MFC Regular DLL (such as an ActiveX Control)
		//  instead of an MFC application, then you will want to
		//  remove this line from DllMain and put it in a separate
		//  function exported from this Extension DLL.  The Regular DLL
		//  that uses this Extension DLL should then explicitly call that
		//  function to initialize this Extension DLL.  Otherwise,
		//  the CDynLinkLibrary object will not be attached to the
		//  Regular DLL's resource chain, and serious problems will
		//  result.

		//	JakubSchwarzmeier::MFC::System::LoadResourceDll( MFCNetDLL );
		new CDynLinkLibrary(MFCNetDLL);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("MFCNet.DLL Terminating!\n");

//		JakubSchwarzmeier::MFC::System::FreeResourceDll( MFCNetDLL );

		// Terminate the library before destructors are called
		AfxTermExtensionModule(MFCNetDLL);
	}
	return 1;   // ok
}

AFX_EXT_CLASS CString JakubSchwarzmeier::MFC::Net::GetLocalName()
{
	//  get name of local computer
	char szLocalName[1024];
	int i = gethostname( szLocalName, sizeof(szLocalName) );
	if (i == SOCKET_ERROR)
	{
		throw new CWindowsException(TRUE);
	}

	return CString(szLocalName);
}

AFX_EXT_CLASS CString JakubSchwarzmeier::MFC::Net::GetLocalAddress()
{
	//  get address of local computer
	HOSTENT * hostent = gethostbyname("");		//  "" can be "localhost"
	
	IN_ADDR addr;
	addr.S_un.S_un_b.s_b1 = hostent->h_addr_list[0][0];
	addr.S_un.S_un_b.s_b2 = hostent->h_addr_list[0][1];
	addr.S_un.S_un_b.s_b3 = hostent->h_addr_list[0][2];
	addr.S_un.S_un_b.s_b4 = hostent->h_addr_list[0][3];
	
	TCHAR szLocalAddress[1024];
	_stprintf( szLocalAddress, _T("%d.%d.%d.%d"),  
		LOBYTE( LOWORD( addr.S_un.S_addr ) ),
		HIBYTE( LOWORD( addr.S_un.S_addr ) ),
		LOBYTE( HIWORD( addr.S_un.S_addr ) ),
		HIBYTE( HIWORD( addr.S_un.S_addr ) )
		);

	return CString(szLocalAddress);
}
