#include "stdafx.h"

#include <MFC.Net.h>

using namespace JakubSchwarzmeier::MFC::Net::Sockets;

CHttpArchetype::CHttpArchetype()
{
	m_contentLength = 0;
	m_contentBuffer = NULL;
	m_dwOutBufferLength = 0;
	m_outBuffer = NULL;
}

CHttpArchetype::~CHttpArchetype()
{
}

void CHttpArchetype::Initialize( CStringA n_s1, CStringA n_s2,
	CStringA n_s3,
	CAtlMap<CStringA, CStringA, 
	CStringAHashTraits, CStringAHashTraits> & n_headerMap,
	unsigned n_contentLength,
	const char * n_contentBuffer,
	DWORD * n_dwOutBufferLength,
	char ** n_outBuffer
	)
{
	m_s1 = n_s1;
	m_s2 = n_s2;
	m_s3 = n_s3;

	POSITION pos = n_headerMap.GetStartPosition();
	CStringA header, content;
	while (pos != NULL)
	{
		n_headerMap.GetNextAssoc( pos, header, content );
		m_headerMap.SetAt( header, content );
	}

	m_contentLength = n_contentLength;
	m_contentBuffer = n_contentBuffer;

	m_dwOutBufferLength = n_dwOutBufferLength;
	m_outBuffer = n_outBuffer;
}

void CHttpArchetype::Create()
{
	JakubSchwarzmeier::MFC::System::IO::CBuffer buffer;

	//  Response: status line, eg. HTTP/1.1 200 OK
	//  Request: status line, eg. POST /Example1/Service1.asmx HTTP/1.0
	
	char szSpace[] = " ";
	buffer += m_s1;
	buffer += szSpace;
	buffer += m_s2;
	buffer += szSpace;
	buffer += m_s3;
	buffer += m_strCRLF;	

	//  add buffer size
	char szLength[32];
	buffer += m_strContentLength;
	buffer += ":";
	buffer += szSpace;
	buffer += _itoa(m_contentLength, szLength, 10);
	buffer += m_strCRLF;

	//  other headers
	POSITION pos = m_headerMap.GetStartPosition();
	CStringA strHeader, strContent;
	while (pos != NULL)
	{
		m_headerMap.GetNextAssoc( pos, strHeader, strContent );
		buffer += strHeader;
		buffer += ":";
		buffer += szSpace;
		buffer += strContent;
		buffer += m_strCRLF;
	}
	
	//  add end of headers
	buffer += m_strCRLF;

	//  update output buffer
	*m_outBuffer = buffer.GetBuffer();
	*m_dwOutBufferLength = buffer.GetLength();
}
