#pragma once

namespace JakubSchwarzmeier
{
	namespace MFC
	{
		namespace Net
		{
			namespace Sockets
			{
				static const CStringA m_strSoapAction = "SOAPAction";
				static const CStringA m_strContentLength = "Content-Length";
				static const CStringA m_strContentType = "Content-Type";
				static const CStringA m_strContentTypeXml8 = "text/xml; charset=utf-8";
				static const CStringA m_strCRLF = "\r\n";
				static const CStringA m_strHTTP11 = "HTTP/1.1";
				static const CStringA m_strBadRequest = "Bad Request";
				static const CStringA m_strOK = "OK";
				static const CStringA m_strServer = "Simulation/Jakub Schwarzmeier/1.0";
				static const CStringA m_strInternalError = "Internal Server Error";
				static const CStringA m_strHandler = "Handler=";
				static const CStringA m_strWSDL = "WSDL";

				class AFX_EXT_CLASS CHttpArchetype
				{
				public:
					// Construction/destruction		
					CHttpArchetype();
					virtual ~CHttpArchetype();

					// Implementation
					// Overridables
					virtual void Initialize( CStringA n_s1, CStringA n_s2,
						CStringA n_s3,
						CAtlMap<CStringA, CStringA, 
						CStringAHashTraits, CStringAHashTraits> & n_headerMap,
						unsigned n_contentLength,
						const char * n_contentBuffer,
						DWORD * n_dwOutBufferLength,
						char ** n_outBuffer
						);

					virtual void Process() = 0;
					virtual void Create();

					// Attributes
	 
				protected:
					// Messages

					CStringA m_s1, m_s2, m_s3;
					CAtlMap<CStringA, CStringA, 
						CStringAHashTraits, CStringAHashTraits> m_headerMap;
                    unsigned m_contentLength;	
					const char * m_contentBuffer;
					DWORD * m_dwOutBufferLength;
					char ** m_outBuffer;

				};	//  end class CHttpArchetype

			}	//  end namespace Sockets
		
		}	//  end namespace Net

	} 	//  end namespace MFC

}	//  end namespace JakubSchwarzmeier

