#pragma once

namespace JakubSchwarzmeier
{
	namespace MFC
	{
		namespace Net
		{
			namespace Sockets
			{
				class AFX_EXT_CLASS CSocketPool: public CObject
				{
				public:
					// Constructors
					CSocketPool();
					virtual ~CSocketPool();

					// Implementation
					
					//  address of local port			
					unsigned short Listen(unsigned short n_port, 
						bool bListenOther = false);
					
					//  address and port of remote machine
					void Connect(int n_ipAddress, unsigned short n_port, 
						bool synchronous = false);

					//  terminate all listening and connecting attemps
					void Close();

					//  when socket handle is closed, it should call this func
					//  to remove it from pool
					void RemoveSocket( CSocket * socketToRemove );

					//  Addresses of accepted remote hosts on listening socket
					//  DWORD IP address can be created with MAKEIPADDRESS macro
					void SetTrustedListening(DWORD dwIPAddress);
					//  Wildcard CString IP address may look like 147.228.10-30.*
					BOOL SetWildTrustedListening(CString & strWildAcceptedRemoteHosts);

					// Overridables
					virtual void OnAccept(CSocket * n_socket);
					virtual void OnConnect(CSocket * n_socket);

					// Attributes
	 
				protected:
					
					//  listening sockets
					CAtlList<SOCKET> m_hListeningSockets;

					//  connecting sockets
					CAtlList<SOCKET> m_hConnectingSockets;

					//  accepted (from listening) and connected sockets
					CAtlList<CSocket*> m_connectedSocketsPool;

					//  message Window
					//
					class CMessageWnd: public CWnd
					{
					public:

						void SetSocketPool( CSocketPool * n_socketPool );
					
					protected:
						
						CSocketPool * m_socketPool;

						// Messages
						afx_msg LRESULT OnNetworkEvent( WPARAM wParam, LPARAM lParam );
						DECLARE_MESSAGE_MAP()
					};

					CString m_strWindowClass;
					CMessageWnd m_messageWnd;

					void CreateMessageWindow();

					::CCriticalSection m_criticalSection;

					//  Conditional acception on listening port
					static int CALLBACK Condition(
						/*[IN]*/ LPWSABUF lpCallerId,
						/*[IN]*/ LPWSABUF lpCallerData,
						/*[IN/OUT]*/ LPQOS lpSQOS,
						/*[IN/OUT]*/ LPQOS lpGQOS,
						/*[IN]*/ LPWSABUF lpCalleeId,
						/*[OUT]*/ LPWSABUF lpCalleeData,
						/*[OUT]*/ GROUP FAR *g,
						/*[IN]*/ DWORD_PTR dwCallbackData
						);

					CAtlList<DWORD> m_acceptedRemoteHosts;
					CString m_strWildAcceptedRemoteHosts;

					DECLARE_DYNAMIC( CSocketPool )
				};	//  end class CSocketPool

			}	//  end namespace Sockets
		
		}	//  end namespace Net

	} 	//  end namespace AfxWin

}	//  end namespace JakubSchwarzmeier

