#pragma once

#include "soapinvoker.h"
#include "sdlgenerator.h"

//  ifndef for case, that web service is statically linked to an application
#ifdef _AFXEXT
	//  Export function names in usable manner.
	//  Keyword PRIVATE prevents entryname from being placed 
	//  in the import library generated by LINK.
	#pragma comment(linker, "/EXPORT:GetWebServiceName=?GetWebServiceName@@YA?AV?$CStringT@DV?$StrTraitMFC_DLL@DV?$ChTraitsCRT@D@ATL@@@@@ATL@@XZ,PRIVATE")
	#pragma comment(linker, "/EXPORT:ExecuteWebMethod=?ExecuteWebMethod@@YA_NAAVCBuffer@IO@System@MFC@JakubSchwarzmeier@@V?$CStringT@_WV?$StrTraitMFC_DLL@_WV?$ChTraitsCRT@_W@ATL@@@@@ATL@@0@Z,PRIVATE")
	#pragma comment(linker, "/EXPORT:WSDL=?WSDL@@YAXAAVCBuffer@IO@System@MFC@JakubSchwarzmeier@@@Z,PRIVATE")

	#define IMPLEMENT_WEB_ROUTINES(nameSpace) \
			namespace nameSpace {	\
				__declspec(dllexport) CComObjectNoLock<C##nameSpace> service; \
			} \
			\
			__declspec(dllexport) CStringA GetWebServiceName() { return nameSpace::C##nameSpace::ServiceName(); } \
			__declspec(dllexport) bool ExecuteWebMethod( \
				JakubSchwarzmeier::MFC::System::IO::CBuffer & inputBuffer, \
				CStringW strSOAPAction, \
				JakubSchwarzmeier::MFC::System::IO::CBuffer & outputBuffer) \
			{ \
				bool bRet = ##nameSpace::service.InvokeSoapMethod(  \
					inputBuffer,  \
					strSOAPAction,  \
					outputBuffer ); \
				return bRet; \
			} \
			__declspec(dllexport) void WSDL( \
				JakubSchwarzmeier::MFC::System::IO::CBuffer & outputBuffer ) \
			{ \
				JakubSchwarzmeier::MFC::Net::WebServices::CSDLGenerator<nameSpace::C##nameSpace> wsdlGen; \
				wsdlGen.RenderWSDL(outputBuffer); \
			}

#else
	static class WebSevices
	{
	public:
		WebSevices()
		{
			//  initialize COM
            CoInitialize( NULL );
		}

		~WebSevices()
		{
			//  deinitialize COM
			CoUninitialize();
		}

	} webservices;

#endif		//  end #ifdef _AFXEXT

