/************************************************************
*
*  Copyright (c) 2004 Jakub Schwarzmeier
*
************************************************************/

#include "stdafx.h"

#include <SFC.System.h>

#include "resource.h"
#include "ExceptionDlg.h"

#include <comdef.h>

CBaseException::CBaseException(BOOL bAutoDelete): CException(bAutoDelete)
{
	m_iHelpID = 0;
}

void CBaseException::SetCause(CString & strCauseBody)
{
	m_strCauseBody = strCauseBody;
}

void CBaseException::SetCause(CString & strCauseBody, 
							  CString & strCauseDetails, int & iHelpID)
{
	m_strCauseBody = strCauseBody;
	m_strCauseDetails = strCauseDetails;
	m_iHelpID = iHelpID;
}

void CBaseException::ReportError()
{
	CExceptionDlg dlgExcept(&m_strCauseBody);	
	dlgExcept.DoModal();
}

CComException::CComException(BOOL bAutoDelete, HRESULT hr): CBaseException(bAutoDelete)
{
		_com_error comError(hr);
		//  pointer to buffer returned by ErrorMessage is destroyed when comError 
		//  goes out of a scope
		const TCHAR * szComError = comError.ErrorMessage();
		m_strCauseBody = szComError;
}

CWindowsException::CWindowsException(BOOL bAutoDelete, DWORD dwCode/*= 0*/): CBaseException(bAutoDelete)
{
	LPTSTR szError;
	//  lpMessage contains error message from Windows

	if (dwCode == 0)	dwCode = ::GetLastError();

	::FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM, NULL, 
		dwCode, 0, reinterpret_cast<LPTSTR>(&szError), 0, NULL);

	m_strCauseBody = szError;

	::LocalFree( szError );
}