#pragma once

namespace JakubSchwarzmeier
{
	namespace SFC
	{
		namespace System
		{
			namespace IO
			{
				enum IOOperation { Read, Write };

				struct  OVERLAPPEDPLUS
				{
					OVERLAPPED ol;  //  does not necessarily have to be the first field
                    IOOperation op;		//  OP_READ, OP_WRITE, defined in .cpp
				};

				class AFX_EXT_CLASS IIOCPStream: public CObject
				{
				public:
					//  Abstract class

					// Constructors
					virtual ~IIOCPStream() {};

					// Implementation
					virtual void ReadFile() = 0;
					virtual void WriteFile(char * lpBuffer, DWORD dwNumberOfBytesToWrite) = 0;

					virtual void OnRead(OVERLAPPEDPLUS * olp, DWORD dwSize) = 0;
					virtual void OnWrite(OVERLAPPEDPLUS * olp, DWORD dwSize) = 0;

					virtual void OnErrorRead(OVERLAPPEDPLUS * olp, DWORD dwSize) = 0;
					virtual void OnErrorWrite(OVERLAPPEDPLUS * olp, DWORD dwSize) = 0;

					// Attributes
					virtual operator HANDLE() const = 0;

				protected:

					DECLARE_DYNAMIC( IIOCPStream )
				};	//  end class CIOCPStream

			}	//  end namespace IO

		}	//  end namespace Sockets

	} 	//  end namespace SFC

}	//  end namespace JakubSchwarzmeier

