/////////////////////////////////////////////////////////////////////////////
// Name:        Observer.h
// Purpose:     
// Author:      
// Modified by: 
// Created:     08/21/06 10:24:11
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

#ifndef _OBSERVERDLG_H_
#define _OBSERVERDLG_H_

#if defined(__GNUG__) && !defined(__APPLE__)
#pragma interface "Observer.cpp"
#endif

/*!
 * Includes
 */

////@begin includes
#include "wx/xrc/xmlres.h"
#include "wx/notebook.h"
////@end includes

#include "openglcanvas.h"
#include "observer.h"
#include <schwarzmeier/std.h>

/*!
 * Forward declarations
 */

////@begin forward declarations
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define IDD_OBSERVER 10007
#define SYMBOL_COBSERVER_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX
#define SYMBOL_COBSERVER_TITLE _("Observer")
#define SYMBOL_COBSERVER_IDNAME IDD_OBSERVER
#define SYMBOL_COBSERVER_SIZE wxSize(400, 300)
#define SYMBOL_COBSERVER_POSITION wxDefaultPosition
////@end control identifiers

/*!
 * Compatibility
 */

#ifndef wxCLOSE_BOX
#define wxCLOSE_BOX 0x1000
#endif
#ifndef wxFIXED_MINSIZE
#define wxFIXED_MINSIZE 0
#endif

/*!
 * CObserver class declaration
 */
namespace JakubSchwarzmeier
{
	namespace wx
	{

		//  forward declaration
		class COpenGLCanvas;
		class CObserver;

class CObserver: public wxDialog
{    
    DECLARE_DYNAMIC_CLASS( CObserver )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CObserver( );
    CObserver( wxWindow* parent, JakubSchwarzmeier::wx::COpenGLCanvas * pglCanvas, wxWindowID id = SYMBOL_COBSERVER_IDNAME, const wxString& caption = SYMBOL_COBSERVER_TITLE, const wxPoint& pos = SYMBOL_COBSERVER_POSITION, const wxSize& size = SYMBOL_COBSERVER_SIZE, long style = SYMBOL_COBSERVER_STYLE );
	virtual ~CObserver();

    /// Creation
    virtual bool Create( wxWindow* parent, JakubSchwarzmeier::wx::COpenGLCanvas * pglCanvas, wxWindowID id = SYMBOL_COBSERVER_IDNAME, const wxString& caption = SYMBOL_COBSERVER_TITLE, const wxPoint& pos = SYMBOL_COBSERVER_POSITION, const wxSize& size = SYMBOL_COBSERVER_SIZE, long style = SYMBOL_COBSERVER_STYLE );

    /// Creates the controls and sizers
    virtual void CreateControls();

////@begin CObserver event handler declarations

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for IDC_ARROW_RIGHT_UP
    void OnCArrowRightUpClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for IDC_ARROW_UP
    void OnCArrowUpClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for IDC_ARROW_LEFT
    void OnCArrowLeftClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for IDC_ARROW_RIGHT
    void OnCArrowRightClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for IDC_ARROW_DOWN
    void OnCArrowDownClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for IDC_ARROW_LEFT_DOWN
    void OnCArrowLeftDownClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_HEADING_LEFT
    void OnHeadingLeftClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_HEADING_RIGHT
    void OnHeadingRightClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_PITCH_UP
    void OnPitchUpClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_PITCH_DOWN
    void OnPitchDownClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_ROLL_CCW
    void OnRollCcwClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_ROLL_CW
    void OnRollCwClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_APPLY2
    void OnApply2Click( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for wxID_CANCEL
    void OnCancelClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_RESETANGLES
    void OnResetAnglesClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_INITIAL
    void OnInitialClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for wxID_APPLY
    void OnApplyClick( wxCommandEvent& event );

////@end CObserver event handler declarations

////@begin CObserver member function declarations

    double GetLambda() const { return m_lambda ; }
    void SetLambda(double value) { m_lambda = value ; }

    double GetPhi() const { return m_phi ; }
    void SetPhi(double value) { m_phi = value ; }

    double GetTheta() const { return m_theta ; }
    void SetTheta(double value) { m_theta = value ; }

    double GetAbsPx() const { return m_abs_px ; }
    void SetAbsPx(double value) { m_abs_px = value ; }

    double GetAbsPy() const { return m_abs_py ; }
    void SetAbsPy(double value) { m_abs_py = value ; }

    double GetHeading() const { return m_heading ; }
    void SetHeading(double value) { m_heading = value ; }

    double GetPitch() const { return m_pitch ; }
    void SetPitch(double value) { m_pitch = value ; }

    double GetRoll() const { return m_roll ; }
    void SetRoll(double value) { m_roll = value ; }

    double GetRelPx() const { return m_rel_px ; }
    void SetRelPx(double value) { m_rel_px = value ; }

    double GetRelPy() const { return m_rel_py ; }
    void SetRelPy(double value) { m_rel_py = value ; }

    double GetRelPz() const { return m_rel_pz ; }
    void SetRelPz(double value) { m_rel_pz = value ; }

    double GetMovementPositionStep() const { return m_movementPositionStep ; }
    void SetMovementPositionStep(double value) { m_movementPositionStep = value ; }

    double GetMovementAngleStep() const { return m_movementAngleStep ; }
    void SetMovementAngleStep(double value) { m_movementAngleStep = value ; }

    double GetAbsPz() const { return m_abs_pz ; }
    void SetAbsPz(double value) { m_abs_pz = value ; }

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CObserver member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin CObserver member variables
    double m_lambda;
    double m_phi;
    double m_theta;
    double m_abs_px;
    double m_abs_py;
    double m_heading;
    double m_pitch;
    double m_roll;
    double m_rel_px;
    double m_rel_py;
    double m_rel_pz;
    double m_movementPositionStep;
    double m_movementAngleStep;
    double m_abs_pz;
////@end CObserver member variables

	double m_prevLambda, m_prevPhi, m_prevTheta;

	void OnUpdateInputs();

    JakubSchwarzmeier::wx::COpenGLCanvas * m_pglCanvas;

	JakubSchwarzmeier::Std::Graphics::RotationMatrix m_initial;

	void SetCamera( JakubSchwarzmeier::Std::Graphics::RotationMatrix & camera );
	JakubSchwarzmeier::Std::Graphics::RotationMatrix * GetCamera();

	JakubSchwarzmeier::Std::Graphics::RotationMatrix * m_pCamera;

	virtual bool UpdateInputs();
	virtual void OnCreateCamera();

	void OnKeyDown(wxKeyEvent & event);
	void OnKeyUp(wxKeyEvent & event);

	virtual void OnMouse(wxMouseEvent& event);

	struct STEP_SIZE {
		// this is how fast our camera moves
		double position; double angle;
	};

	void SetPositionSpeed(double stepSize);
	void SetAngleSpeed(double stepSize);
	double GetPositionSpeed();
	double GetAngleSpeed();


	void CalculateFrameRate();
	double m_framesPerSecond; //  FPS

	bool m_keys[0x400];
	STEP_SIZE m_stepSize;


	virtual void Show( wxWindow * parent, JakubSchwarzmeier::wx::COpenGLCanvas * pglCanvas );
	void SetOpenGLCanvas( JakubSchwarzmeier::wx::COpenGLCanvas * pglCanvas );
};

}
}

#endif
    // _OBSERVERDLG_H_
