/////////////////////////////////////////////////////////////////////////////
// Name:        OpenGLCanvasDlg.h
// Purpose:     
// Author:      
// Modified by: 
// Created:     11/01/05 15:43:56
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

#ifndef _OPENGLCANVASDLG_H_
#define _OPENGLCANVASDLG_H_

#if defined(__GNUG__) && !defined(__APPLE__)
#pragma interface "ObserverDlg.cpp"
#endif

/*!
 * Includes
 */

#include "observer.h"

////@begin includes
#include "wx/xrc/xmlres.h"
#include "wx/notebook.h"
#include "wx/listctrl.h"
////@end includes

#include <wx/radiobut.h>
#include <wx/checkbox.h>

#include <wx/sizer.h>
#include <wx/stattext.h>
#include <wx/intl.h>

/*!
 * Forward declarations
 */

////@begin forward declarations
class wxNotebook;
class wxListCtrl;
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_OPENGLCANVASDLG 10000
#define SYMBOL_COPENGLCANVASDLG_STYLE wxCAPTION|wxSYSTEM_MENU|wxCLOSE_BOX
#define SYMBOL_COPENGLCANVASDLG_TITLE _("OpenGL")
#define SYMBOL_COPENGLCANVASDLG_IDNAME ID_OPENGLCANVASDLG
#define SYMBOL_COPENGLCANVASDLG_SIZE wxSize(400, 300)
#define SYMBOL_COPENGLCANVASDLG_POSITION wxDefaultPosition
////@end control identifiers

/*!
 * Compatibility
 */

#ifndef wxCLOSE_BOX
#define wxCLOSE_BOX 0x1000
#endif
#ifndef wxFIXED_MINSIZE
#define wxFIXED_MINSIZE 0
#endif

/*!
 * COpenGLCanvasDlg class declaration
 */

namespace JakubSchwarzmeier
{
	namespace wx
	{

		//  forward declaration
		class COpenGLCanvas;

class COpenGLCanvasDlg: public wxDialog
{    
    DECLARE_DYNAMIC_CLASS( COpenGLCanvasDlg )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    COpenGLCanvasDlg( );
    COpenGLCanvasDlg( wxWindow* parent, wxWindowID id = SYMBOL_COPENGLCANVASDLG_IDNAME, const wxString& caption = SYMBOL_COPENGLCANVASDLG_TITLE, const wxPoint& pos = SYMBOL_COPENGLCANVASDLG_POSITION, const wxSize& size = SYMBOL_COPENGLCANVASDLG_SIZE, long style = SYMBOL_COPENGLCANVASDLG_STYLE );
    COpenGLCanvasDlg( wxWindow* parent, JakubSchwarzmeier::wx::COpenGLCanvas * pglCanvas, wxWindowID id = SYMBOL_COPENGLCANVASDLG_IDNAME, const wxString& caption = SYMBOL_COPENGLCANVASDLG_TITLE, const wxPoint& pos = SYMBOL_COPENGLCANVASDLG_POSITION, const wxSize& size = SYMBOL_COPENGLCANVASDLG_SIZE, long style = SYMBOL_COPENGLCANVASDLG_STYLE );
	~COpenGLCanvasDlg();

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_COPENGLCANVASDLG_IDNAME, const wxString& caption = SYMBOL_COPENGLCANVASDLG_TITLE, const wxPoint& pos = SYMBOL_COPENGLCANVASDLG_POSITION, const wxSize& size = SYMBOL_COPENGLCANVASDLG_SIZE, long style = SYMBOL_COPENGLCANVASDLG_STYLE );

    /// Creates the controls and sizers
    void CreateControls();

////@begin COpenGLCanvasDlg event handler declarations

    /// wxEVT_COMMAND_CHECKBOX_CLICKED event handler for ID_CHECKBOX
    void OnTexturingSelected( wxCommandEvent& event );

    /// wxEVT_COMMAND_CHECKBOX_CLICKED event handler for ID_LIGHTING
    void OnLightingClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_CHECKBOX_CLICKED event handler for ID_COLORMATERIAL
    void OnColormaterialClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_CHECKBOX_CLICKED event handler for ID_FACECULLING
    void OnFacecullingClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_CHOICE_SELECTED event handler for ID_POLYGON_MODE
    void OnPolygonModeSelected( wxCommandEvent& event );

////@end COpenGLCanvasDlg event handler declarations

////@begin COpenGLCanvasDlg member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end COpenGLCanvasDlg member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin COpenGLCanvasDlg member variables
    wxNotebook* m_notebook;
    wxCheckBox* m_texturingCtrl;
    wxCheckBox* m_lightingCtrl;
    wxCheckBox* m_colorMaterialCtrl;
    wxCheckBox* m_faceCullingCtrl;
    wxChoice* m_polygonModeCtrl;
    wxStaticBoxSizer* m_infosizer;
    wxStaticText* m_vendor;
    wxStaticText* m_renderer;
    wxStaticText* m_version;
    wxListCtrl* m_extensions;
////@end COpenGLCanvasDlg member variables

    JakubSchwarzmeier::wx::COpenGLCanvas * m_pglCanvas;
};

	}
}

#endif
    // _OPENGLCANVASDLG_H_
