#ifndef __3DMODEL__
#define __3DMODEL__

#include <schwarzmeier/std.h>
#include "openglcanvas.h"

namespace JakubSchwarzmeier
{
	namespace wx
	{
		class CThreedModel
		{
		public:

			CThreedModel(COpenGLCanvas * openGLCanvas);
			~CThreedModel();
			virtual void Load( std::string filename ) = 0;
			virtual void Render();

			static CThreedModel * Create( std::string filename, COpenGLCanvas * openGLCanvas );

		protected:

			struct TEX_TYPE
			{
				double s, t;
			};

			COpenGLCanvas * m_pOpenGLCanvas;
			GLuint m_displayList;
		};

	}  //  end namespace wx

}  //  end namespace JakubSchwarzmeier

#endif // __3DMODEL__