/*
*
*  Copyright (c) 2006 Jakub Schwarzmeier
*
************************************************************/

#include "stdwx.h"

#include "app.h"
#include "xh_docmainframe.h"


// CApp

// The event tables connect the wxWidgets events with the functions (event
// handlers) which process them. It can be also done at run-time, but for the
// simple menu events like this the static method is much simpler.

BEGIN_EVENT_TABLE(JakubSchwarzmeier::wx::CApp, wxApp)
    EVT_MENU(XRCID("wxID_NEW"), CApp::OnFileNew)
    EVT_MENU(XRCID("wxID_EXIT"), CApp::OnAppQuit)
END_EVENT_TABLE()

using namespace JakubSchwarzmeier::wx;

// CApp construction

CApp::CApp()
{
	m_docManager = NULL;
	m_frame = NULL;
}


// CApp initialization
bool CApp::OnInit()
{
	//// Create a document manager
	m_docManager = new wxDocManager;

	wxXmlResource::Get()->AddHandler(new wxDocMDIParentFrameXmlHandler);

	//  Set locale for program to system default locale
	m_locale.Init();

	SetVendorName( _T("Jakub_Schwarzmeier") );

    // Return true to tell program to continue (false would terminate).
	return true;
}

int CApp::OnExit()
{
    delete m_docManager;
    return wxApp::OnExit();
}

wxDocManager * CApp::GetDocManager()
{
	return m_docManager;
}

wxLocale * CApp::GetLocale()
{
	return &m_locale;
}

void CApp::OnAppQuit(wxCommandEvent& event)
{
	m_frame->Close();
}

void CApp::OnFileNew(wxCommandEvent& event)
{
	//  Create new document
	wxList & list = m_docManager->GetTemplates();
        wxList::compatibility_iterator node = wxDocManager::GetDocumentManager()->GetTemplates().GetFirst();
	wxDocTemplate * pTemplate = (wxDocTemplate*) node->GetData();

	wxDocument * pDoc = pTemplate->CreateDocument( wxEmptyString, wxDOC_NEW );
}
