/*
*
*  Copyright (c) 2002-2005 Jakub Schwarzmeier
*
************************************************************/

#include "stdwx.h"

#include "docchildframe.h"
#include "view.h"
#include "serializereaderwriter.h"

using namespace JakubSchwarzmeier::wx;

IMPLEMENT_DYNAMIC_CLASS (CDocChildFrame, wxDocMDIChildFrame)

BEGIN_EVENT_TABLE(CDocChildFrame, wxDocMDIChildFrame)
    EVT_PAINT(CDocChildFrame::OnPaint)
	EVT_ERASE_BACKGROUND(CDocChildFrame::OnEraseBkgnd)
END_EVENT_TABLE()

CDocChildFrame::CDocChildFrame(wxDocument *doc, wxView *view, wxMDIParentFrame *frame)
{
	Create(doc, view, frame, false);
}

void CDocChildFrame::Create(wxDocument *doc, wxView *view, wxMDIParentFrame *frame, bool bDeserialize)
{
	wxDocMDIChildFrame::Create(doc, view, frame, wxID_ANY, doc->GetTitle() );
}

CDocChildFrame::CDocChildFrame()
{
}

CDocChildFrame::~CDocChildFrame()
{
}

void CDocChildFrame::OnPaint(wxPaintEvent& event )
{
	wxPaintDC dc( this );	//  must be called!
	PrepareDC( dc );
	if (m_childView != NULL)  m_childView->OnDraw( &dc );
}

void CDocChildFrame::OnEraseBkgnd( wxEraseEvent& event )
{
	if (m_childView != NULL)
	{
		if (event.GetDC())
		{
			static_cast<CView*>( m_childView )->OnEraseBkgnd( event.GetDC() );
		}
		else
		{
			wxClientDC dc(this);
			static_cast<CView*>( m_childView )->OnEraseBkgnd( &dc );
		}
	}
}

bool CDocChildFrame::OnSerialize( JakubSchwarzmeier::wx::CSerializeReaderWriter * dir )
{
	

	return true;
}

