#ifndef _WX_GLCANVASWIN_
#define _WX_GLCANVASWIN_

#define GLEW_MX
#include <GL/glew.h>
#include <GL/wglew.h>
#include <wx/glcanvas.h>

#include "SerializeReaderWriter.h"

namespace JakubSchwarzmeier
{
	namespace wx
	{
		class wxMyGLContext: public wxGLContext
		{
		public:

			wxMyGLContext() {};
			wxMyGLContext(bool isRGB, wxGLCanvas *win, const wxPalette& palette = wxNullPalette, const wxMyGLContext *other = NULL);
			void Create(bool isRGB, wxGLCanvas *win, bool bDeserialize = false, const wxPalette& palette = wxNullPalette, const wxMyGLContext *other = NULL);
			~wxMyGLContext();

			GLEWContext * glewGetContext();
			WGLEWContext * wglewGetContext();

			void CreatePBuffer();
			void DontUsePBuffer();
			void GetCopyImage(wxImage & newImage);
			wxImage GetImage();
			void UpdatePBuffer();
			void ResizePBuffer();
			void SetCurrent();
			void UnsetCurrent();
			void SwapBuffers();

		protected:

			GLEWContext m_glewCtx;
			WGLEWContext m_wglewCtx;

			//  PBuffer
			HPBUFFERARB m_hbuffer;
			WXHDC m_hDCWindow;
			wxImage * m_image;
			unsigned char * m_bitmapData;

			virtual bool OnSerialize( JakubSchwarzmeier::wx::CSerializeReaderWriter * dir );

			DECLARE_DYNAMIC_CLASS(wxMyGLContext)
		};

	}	//  end namespace wx
}	//  end namespace JakubSchwarzmeier

#endif