/*
*
*  Copyright (c) 2002-2005 Jakub Schwarzmeier
*
************************************************************/

#include "stdwx.h"

#include "openglview.h"

#include "SerializeReaderWriter.h"

using namespace JakubSchwarzmeier::wx;

IMPLEMENT_DYNAMIC_CLASS (COpenGLView, CView)

BEGIN_EVENT_TABLE(COpenGLView, CView)
END_EVENT_TABLE()


COpenGLView::COpenGLView()
{
	m_openGLCanvas = NULL;
}

COpenGLView::~COpenGLView()
{
	if (m_openGLCanvas != NULL)	m_openGLCanvas->Destroy();
}

void COpenGLView::OnDraw(wxDC * dc)
{
	if (m_openGLCanvas != NULL)	m_openGLCanvas->Refresh();
}

void COpenGLView::SetFrame(wxWindow* frame)
{
	CView::SetFrame(frame);

	if ((m_openGLCanvas != NULL) && (CSerializeReaderWriter::IsResurrection() == true))
	{
			m_openGLCanvas->Create( GetFrame(), true );
	}
	else
	if (m_openGLCanvas == NULL)
	{
		m_openGLCanvas = new COpenGLCanvas( GetFrame() );
	}
}

bool COpenGLView::OnSerialize( JakubSchwarzmeier::wx::CSerializeReaderWriter * dir )
{
	dir->Append( reinterpret_cast<wxObject**>( &m_openGLCanvas ), wxString("m_openGLCanvas") );
	return true;
}

COpenGLCanvas * COpenGLView::GetCanvas()
{
	return m_openGLCanvas;
}
