/************************************************************
*
*  Copyright (c) 2005 Jakub Schwarzmeier
*
************************************************************/

#ifndef _WX_VALINT_H_
#define _WX_VALINT_H_

class wxIntegerValidator: public wxValidator
{
DECLARE_DYNAMIC_CLASS(wxIntegerValidator)
public:
	wxIntegerValidator(int * val = NULL);
	wxIntegerValidator(const wxIntegerValidator& copyFrom);

    // Make a clone of this validator (or return NULL) - currently necessary
    // if you're passing a reference to a validator.
    // Another possibility is to always pass a pointer to a new validator
    // (so the calling code can use a copy constructor of the relevant class).
    virtual wxObject *Clone() const { return new wxIntegerValidator(*this); }
	bool Copy(const wxIntegerValidator& val);

    // Called when the value in the window must be validated.
    // This function can pop up an error message.
    virtual bool Validate(wxWindow *parent);

    // Called to transfer data to the window
    virtual bool TransferToWindow();

    // Called to transfer data to the window
    virtual bool TransferFromWindow();

protected:

	int * m_pVal;
};

#endif // _WX_VALINT_H_