/************************************************************
*
*  Copyright (c) 2006 Jakub Schwarzmeier
*
************************************************************/

#ifndef _WX_VALNOTNULL_H_
#define _WX_VALNOTNULL_H_

class wxNotNullValidator: public wxValidator
{
DECLARE_DYNAMIC_CLASS(wxNotNullValidator)
public:
	wxNotNullValidator();
	wxNotNullValidator(wxString * val, wxString errString);
	wxNotNullValidator(const wxNotNullValidator& copyFrom);

    // Make a clone of this validator (or return NULL) - currently necessary
    // if you're passing a reference to a validator.
    // Another possibility is to always pass a pointer to a new validator
    // (so the calling code can use a copy constructor of the relevant class).
    virtual wxObject *Clone() const { return new wxNotNullValidator(*this); }
	bool Copy(const wxNotNullValidator& val);

    // Called when the value in the window must be validated.
    // This function can pop up an error message.
    virtual bool Validate(wxWindow *parent);

    // Called to transfer data to the window
    virtual bool TransferToWindow();

    // Called to transfer data to the window
    virtual bool TransferFromWindow();

protected:

	wxString * m_pVal;
	wxString m_errString;
};

#endif // _WX_VALNOTNULL_H_
