#pragma once

#include <highgui.h>
#include <string>
#include "visualization.h"
#include "rectangularobserver.h"
#include "sphericalobserver.h"

class CAnimation
{
public:
	CAnimation(void);
	~CAnimation(void);

	size_t Create (CVisualization * vis, double fps, int w, int h);
	void Update();

protected:

	CvVideoWriter * m_pVideoWriter;
	double m_fps;
	int m_width, m_height;

	size_t m_iChunk;
	signed int m_iChunkPos;

	CRectangularObserver * m_pRectangular;
	CSphericalObserver * m_pSpherical;

	wxImage m_image;

	CVisualization * m_pVisualization;
	std::vector<CChunkDesc*> * m_pChunks;
};
