/////////////////////////////////////////////////////////////////////////////
// Name:        BodiesDlg.h
// Purpose:     
// Author:      Jakub Schwarzmeier
// Modified by: 
// Created:     08/11/06 11:33:24
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

#ifndef _BODIESDLG_H_
#define _BODIESDLG_H_

#if defined(__GNUG__) && !defined(__APPLE__)
#pragma interface "BodiesDlg.cpp"
#endif

/*!
 * Includes
 */

////@begin includes
#include "wx/xrc/xmlres.h"
#include "wx/treectrl.h"
////@end includes

#include <map>
#include <set>
#include "body.h"

/*!
 * Forward declarations
 */

////@begin forward declarations
class wxTreeCtrl;
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define IDD_BODIES 10004
#define SYMBOL_CBODIESDLG_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX
#define SYMBOL_CBODIESDLG_TITLE _("Bodies")
#define SYMBOL_CBODIESDLG_IDNAME IDD_BODIES
#define SYMBOL_CBODIESDLG_SIZE wxSize(400, 300)
#define SYMBOL_CBODIESDLG_POSITION wxDefaultPosition
////@end control identifiers

/*!
 * Compatibility
 */

#ifndef wxCLOSE_BOX
#define wxCLOSE_BOX 0x1000
#endif
#ifndef wxFIXED_MINSIZE
#define wxFIXED_MINSIZE 0
#endif

/*!
 * CBodiesDlg class declaration
 */

class CBodiesDlg: public wxDialog
{    
    DECLARE_DYNAMIC_CLASS( CBodiesDlg )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CBodiesDlg( );
    CBodiesDlg( wxWindow* parent, wxWindowID id = SYMBOL_CBODIESDLG_IDNAME, const wxString& caption = SYMBOL_CBODIESDLG_TITLE, const wxPoint& pos = SYMBOL_CBODIESDLG_POSITION, const wxSize& size = SYMBOL_CBODIESDLG_SIZE, long style = SYMBOL_CBODIESDLG_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CBODIESDLG_IDNAME, const wxString& caption = SYMBOL_CBODIESDLG_TITLE, const wxPoint& pos = SYMBOL_CBODIESDLG_POSITION, const wxSize& size = SYMBOL_CBODIESDLG_SIZE, long style = SYMBOL_CBODIESDLG_STYLE );

    /// Creates the controls and sizers
    void CreateControls();

////@begin CBodiesDlg event handler declarations

    /// wxEVT_COMMAND_TREE_SEL_CHANGED event handler for ID_BODIES
    void OnBodiesSelChanged( wxTreeEvent& event );

    /// wxEVT_COMMAND_TREE_ITEM_ACTIVATED event handler for ID_BODIES
    void OnBodiesItemActivated( wxTreeEvent& event );

    /// wxEVT_COMMAND_CHOICE_SELECTED event handler for ID_CLASSES
    void OnClassesSelected( wxCommandEvent& event );

    /// wxEVT_UPDATE_UI event handler for ID_CLASSES
    void OnClassesUpdate( wxUpdateUIEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_ADDBODY
    void OnAddbodyClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_REMOVEBODY
    void OnRemovebodiesClick( wxCommandEvent& event );

    /// wxEVT_UPDATE_UI event handler for ID_REMOVEBODY
    void OnRemovebodiesUpdate( wxUpdateUIEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_PROPSBODY
    void OnPropsbodyClick( wxCommandEvent& event );

    /// wxEVT_UPDATE_UI event handler for ID_PROPSBODY
    void OnPropsbodyUpdate( wxUpdateUIEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_ADDBODIES
    void OnAddbodiesClick( wxCommandEvent& event );

    /// wxEVT_UPDATE_UI event handler for ID_ADDBODIES
    void OnAddbodiesUpdate( wxUpdateUIEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_SPICEFILES
    void OnSpicefilesClick( wxCommandEvent& event );

////@end CBodiesDlg event handler declarations

////@begin CBodiesDlg member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CBodiesDlg member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

protected:

	void UpdateBodies();
	void UpdateAvailableBodies( std::set<std::string> * set );
	void UpdateActiveBodies(std::set<std::string> * set);

	void LocalTreeStructure( Body * body, wxTreeItemId & parentTreeItem, std::set<std::string> * set );

////@begin CBodiesDlg member variables
    wxTreeCtrl* m_bodiesCtrl;
    wxChoice* m_classes;
    wxTreeCtrl* m_availBodiesCtrl;
////@end CBodiesDlg member variables

	std::map<wxString, wxString> m_mapClasses;
};

#endif
    // _BODIESDLG_H_
