/////////////////////////////////////////////////////////////////////////////
// Name:        BodyLocaleNameDlg.h
// Purpose:     
// Author:      Jakub Schwarzmeier
// Modified by: 
// Created:     09/17/06 09:01:40
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

#ifndef _BODYLOCALENAMEDLG_H_
#define _BODYLOCALENAMEDLG_H_

#if defined(__GNUG__) && !defined(__APPLE__)
#pragma interface "BodyLocaleNameDlg.cpp"
#endif

/*!
 * Includes
 */

////@begin includes
#include "wx/xrc/xmlres.h"
#include "wx/listctrl.h"
////@end includes

/*!
 * Forward declarations
 */

////@begin forward declarations
class wxListCtrl;
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define IDD_BODYLOCALENAME 10088
#define SYMBOL_CBODYLOCALENAMEDLG_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX
#define SYMBOL_CBODYLOCALENAMEDLG_TITLE _("Body Locale Name ")
#define SYMBOL_CBODYLOCALENAMEDLG_IDNAME IDD_BODYLOCALENAME
#define SYMBOL_CBODYLOCALENAMEDLG_SIZE wxSize(400, 300)
#define SYMBOL_CBODYLOCALENAMEDLG_POSITION wxDefaultPosition
////@end control identifiers

/*!
 * Compatibility
 */

#ifndef wxCLOSE_BOX
#define wxCLOSE_BOX 0x1000
#endif
#ifndef wxFIXED_MINSIZE
#define wxFIXED_MINSIZE 0
#endif

/*!
 * CBodyLocaleNameDlg class declaration
 */

class CBodyLocaleNameDlg: public wxDialog
{    
    DECLARE_DYNAMIC_CLASS( CBodyLocaleNameDlg )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CBodyLocaleNameDlg( );
    CBodyLocaleNameDlg( wxWindow* parent, wxWindowID id = SYMBOL_CBODYLOCALENAMEDLG_IDNAME, const wxString& caption = SYMBOL_CBODYLOCALENAMEDLG_TITLE, const wxPoint& pos = SYMBOL_CBODYLOCALENAMEDLG_POSITION, const wxSize& size = SYMBOL_CBODYLOCALENAMEDLG_SIZE, long style = SYMBOL_CBODYLOCALENAMEDLG_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CBODYLOCALENAMEDLG_IDNAME, const wxString& caption = SYMBOL_CBODYLOCALENAMEDLG_TITLE, const wxPoint& pos = SYMBOL_CBODYLOCALENAMEDLG_POSITION, const wxSize& size = SYMBOL_CBODYLOCALENAMEDLG_SIZE, long style = SYMBOL_CBODYLOCALENAMEDLG_STYLE );

    /// Creates the controls and sizers
    void CreateControls();

////@begin CBodyLocaleNameDlg event handler declarations

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_ADD
    void OnAddClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for wxID_OK
    void OnOkClick( wxCommandEvent& event );

////@end CBodyLocaleNameDlg event handler declarations

////@begin CBodyLocaleNameDlg member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CBodyLocaleNameDlg member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin CBodyLocaleNameDlg member variables
    wxListCtrl* m_localeCtrl;
////@end CBodyLocaleNameDlg member variables
};

#endif
    // _BODYLOCALENAMEDLG_H_
