#include "stdafx.h"

#include "Body.h"
#include "Comet.h"
#include "ExtendedBody.h"
#include "BodyPropertiesDlg.h"

IMPLEMENT_CLASS(CBodyPropertiesDlg, wxPropertySheetDialog)

BEGIN_EVENT_TABLE(CBodyPropertiesDlg, wxPropertySheetDialog)

	EVT_BUTTON( wxID_OK, CBodyPropertiesDlg::OnOK )

END_EVENT_TABLE()

CBodyPropertiesDlg::CBodyPropertiesDlg()
{
}

CBodyPropertiesDlg::CBodyPropertiesDlg(wxWindow* win)
{
	Create(win);
}

bool CBodyPropertiesDlg::Create(wxWindow* win)
{
    SetExtraStyle(wxWS_EX_VALIDATE_RECURSIVELY);

	wxPropertySheetDialog::Create(win, wxID_ANY, _("Preferences"), wxDefaultPosition, wxDefaultSize,
        wxDEFAULT_DIALOG_STYLE
        |wxRESIZE_BORDER
    );

    CreateButtons(wxOK|wxCANCEL);

	Body * body = reinterpret_cast<Body*>( GetClientData() );

    wxBookCtrlBase * notebook = GetBookCtrl();

	//  windows are relase automatically
    m_pBodiesPnl = new CBodyPropertiesPnl;
	m_pBodiesPnl->SetClientData( GetClientData() );
	m_pBodiesPnl->Create(notebook);

    notebook->AddPage(m_pBodiesPnl, SYMBOL_CBODYPROPERTIESPNL_TITLE );

	if ( body->GetClassInfo()->IsKindOf( CLASSINFO( Comet ) ) )
	{
		m_pCometsPnl = new CCometPropertiesPnl;
		m_pCometsPnl->SetClientData( GetClientData() );
		m_pCometsPnl->Create(notebook);

		notebook->AddPage(m_pCometsPnl, SYMBOL_CCOMETPROPERTIESPNL_TITLE );
	}

	if ( body->GetClassInfo()->IsKindOf( CLASSINFO( ExtendedBody ) ) )
	{
		m_pExtendedBodyPnl = new CExtendedBodyPropertiesPnl;
		m_pExtendedBodyPnl->SetClientData( GetClientData() );
		m_pExtendedBodyPnl->Create(notebook);

		notebook->AddPage(m_pExtendedBodyPnl, SYMBOL_CEXTENDEDBODYPROPERTIESPNL_TITLE );
	}

	if ( body->GetClassInfo()->IsKindOf( CLASSINFO( IrregularBody ) ) )
	{
		m_pIrregularBodyPnl = new CIrregularBodyPropertiesPnl;
		m_pIrregularBodyPnl->SetClientData( GetClientData() );
		m_pIrregularBodyPnl->Create(notebook);

		notebook->AddPage(m_pIrregularBodyPnl, SYMBOL_CIRREGULARBODYPROPERTIESPNL_TITLE );
	}

    LayoutDialog();
    Centre();

	return true;
}

void CBodyPropertiesDlg::OnOK( wxCommandEvent &event )
{
	if ( Validate() && TransferDataFromWindow() )
	{
		EndDialog( wxID_OK );
	}
}