/////////////////////////////////////////////////////////////////////////////
// Name:        BodyPropertiesPnl.h
// Purpose:     
// Author:      Jakub Schwarzmeier
// Modified by: 
// Created:     08/13/06 15:02:41
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

#ifndef _BODYPROPERTIESPNL_H_
#define _BODYPROPERTIESPNL_H_

#if defined(__GNUG__) && !defined(__APPLE__)
#pragma interface "BodyPropertiesPnl.cpp"
#endif

/*!
 * Includes
 */

////@begin includes
#include "wx/xrc/xmlres.h"
////@end includes

/*!
 * Forward declarations
 */

////@begin forward declarations
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define IDD_BODYPROPERTIES 10001
#define SYMBOL_CBODYPROPERTIESPNL_STYLE 0
#define SYMBOL_CBODYPROPERTIESPNL_TITLE _("Body")
#define SYMBOL_CBODYPROPERTIESPNL_IDNAME IDD_BODYPROPERTIES
#define SYMBOL_CBODYPROPERTIESPNL_SIZE wxSize(400, 300)
#define SYMBOL_CBODYPROPERTIESPNL_POSITION wxDefaultPosition
////@end control identifiers

/*!
 * Compatibility
 */

#ifndef wxCLOSE_BOX
#define wxCLOSE_BOX 0x1000
#endif
#ifndef wxFIXED_MINSIZE
#define wxFIXED_MINSIZE 0
#endif

/*!
 * CBodyPropertiesPnl class declaration
 */

class CBodyPropertiesPnl: public wxPanel
{    
    DECLARE_DYNAMIC_CLASS( CBodyPropertiesPnl )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CBodyPropertiesPnl( );
    CBodyPropertiesPnl( wxWindow* parent, wxWindowID id = SYMBOL_CBODYPROPERTIESPNL_IDNAME, const wxPoint& pos = SYMBOL_CBODYPROPERTIESPNL_POSITION, const wxSize& size = SYMBOL_CBODYPROPERTIESPNL_SIZE, long style = SYMBOL_CBODYPROPERTIESPNL_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CBODYPROPERTIESPNL_IDNAME, const wxPoint& pos = SYMBOL_CBODYPROPERTIESPNL_POSITION, const wxSize& size = SYMBOL_CBODYPROPERTIESPNL_SIZE, long style = SYMBOL_CBODYPROPERTIESPNL_STYLE );

    /// Creates the controls and sizers
    void CreateControls();

////@begin CBodyPropertiesPnl event handler declarations

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_LOCALE
    void OnLocaleClick( wxCommandEvent& event );

    /// wxEVT_UPDATE_UI event handler for ID_VZ
    void OnUpdateNonSpice( wxUpdateUIEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_CHOOSECOLOR
    void OnChoosecolorClick( wxCommandEvent& event );

////@end CBodyPropertiesPnl event handler declarations

////@begin CBodyPropertiesPnl member function declarations

    double GetPx() const { return m_px ; }
    void SetPx(double value) { m_px = value ; }

    double GetPy() const { return m_py ; }
    void SetPy(double value) { m_py = value ; }

    double GetPz() const { return m_pz ; }
    void SetPz(double value) { m_pz = value ; }

    double GetVx() const { return m_vx ; }
    void SetVx(double value) { m_vx = value ; }

    double GetVy() const { return m_vy ; }
    void SetVy(double value) { m_vy = value ; }

    double GetVz() const { return m_vz ; }
    void SetVz(double value) { m_vz = value ; }

    double GetMass() const { return m_mass ; }
    void SetMass(double value) { m_mass = value ; }

    int GetSpiceID() const { return m_spiceID ; }
    void SetSpiceID(int value) { m_spiceID = value ; }

    wxString GetName() const { return m_name ; }
    void SetName(wxString value) { m_name = value ; }

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CBodyPropertiesPnl member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin CBodyPropertiesPnl member variables
    wxCheckBox* m_useSpiceCtrl;
    double m_px;
    double m_py;
    double m_pz;
    double m_vx;
    double m_vy;
    double m_vz;
    double m_mass;
    int m_spiceID;
    wxString m_name;
////@end CBodyPropertiesPnl member variables

	virtual bool TransferDataFromWindow();
};

#endif
    // _BODYPROPERTIESPNL_H_
