#pragma once
#include "renderingtarget.h"
#include "body.h"
#include "visualization.h"

class CBodyTarget :
	public CRenderingTarget
{
public:
	CBodyTarget(Body * body, CVisualization * visualization);
	virtual ~CBodyTarget(void);

	virtual void Render();
	virtual void PreRender();
	virtual void OnContextTerminate();
	virtual void DrawTrajectory();
	virtual void ClearTrajectory();

	virtual double GetFurthermostDistance();
	virtual double GetNearestDistance();
	virtual bool IsLarge();

	virtual JakubSchwarzmeier::Std::Graphics::RotationMatrix GetObjectInEye();

	virtual void Trajectory();
	virtual void DrawName();

protected:

	Body * m_pBody;
	CVisualization * m_pVisualization;

	double m_T;		//  period of body's orbit in seconds
	double m_tLastSave;
	std::vector< JakubSchwarzmeier::Std::Math::Vector<> > m_positions;

	static size_t s_nRememberPeriods;
	static size_t s_nPositionsPerPeriod;
};
