#include "StdAfx.h"
#include ".\camera.h"

IMPLEMENT_DYNAMIC_CLASS(CCamera, wxObject)

CCamera::CCamera(void)
{
    //  dispatch
	mapDispatch.insert( MAPDISPATCH::value_type( this->GetClassInfo() , Assign2 ) );
}

CCamera::~CCamera(void)
{
}

CCamera::CCamera( const CCamera & original )
{
	operator=( original );
}

void CCamera::Assign(CCamera * camera) 
{
	MAPDISPATCH::const_iterator it1 = mapDispatch.find( this->GetClassInfo() );
	MAPDISPATCH::const_iterator it2 = mapDispatch.find( camera->GetClassInfo() );

	if ( it1->first->IsKindOf( it2->first ) )
	{
		it2->second( this, camera );
	}
	else
	{
		it1->second( this, camera );
	}
}	

/* static */
void CCamera::Assign2(CCamera * camera, CCamera * right_side) 
{
	camera->operator=( *right_side );
}

CCamera & CCamera::operator=( const CCamera & right_side )
{
	if ( &right_side == this )  return (*this);

	RotationMatrix::operator=( right_side );

	return *this;
}

xmlNode * CCamera::Serialize(xmlDoc * pXmlDoc, xmlNode * pXmlNode)
{
	//  class
	xmlNewProp( pXmlNode, (const xmlChar *)s_strClass.c_str(), (const xmlChar *)this->GetClassInfo()->GetClassName() );

	return pXmlNode;
}

CCamera * CCamera::Deserialize( xmlNode * pXmlNode )
{
	xmlChar * attr = xmlGetProp(pXmlNode, (const xmlChar *) s_strClass.c_str() );
	std::string strClassName( reinterpret_cast<char*>(attr) );
	xmlFree(attr);

	wxClassInfo * classInfo = wxClassInfo::FindClass( strClassName.c_str() );
	if ( !classInfo->IsKindOf( CLASSINFO(CCamera) ) )
	{
		throw;
	}

	return dynamic_cast<CCamera*>( ::wxCreateDynamicObject( strClassName.c_str() ) );
}

void CCamera::Deserialize(xmlDoc * pXmlDoc, xmlNode * pXmlNode )
{
	//  nothing todo, maybe save RotationMatrix matrix
}

std::string CCamera::s_strClass( _T("class") );
