#pragma once

#include <schwarzmeier/wx.h>

class CCamera :
	public JakubSchwarzmeier::Std::Graphics::RotationMatrix, public wxObject
{
public:
	CCamera(void);
	virtual ~CCamera(void);

	CCamera( const CCamera & original );
	CCamera & operator=( const CCamera & right_side );

	void Assign(CCamera * camera);

	static CCamera * Deserialize( xmlNode * pXmlNode ) ;

	virtual xmlNode * Serialize(xmlDoc * pXmlDoc, xmlNode * pXmlNode);
	virtual void Deserialize( xmlDoc * pXmlDoc, xmlNode * pXmlNode );

	virtual void Update() {}		//  gives room for updating camera; call it when body moves 
	
protected:

	//  dispatch table
	typedef std::map<const wxClassInfo*, void(*)(CCamera*,CCamera*)> MAPDISPATCH;
	MAPDISPATCH mapDispatch;

	static void Assign2(CCamera * camera, CCamera * right_side);

	static std::string s_strClass;

	DECLARE_DYNAMIC_CLASS (CCamera)
};
