/////////////////////////////////////////////////////////////////////////////
// Name:        CamerasPanel.h
// Purpose:     
// Author:      Jakub Schwarzmeier
// Modified by: 
// Created:     08/20/06 11:02:11
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

#ifndef _CAMERASPANEL_H_
#define _CAMERASPANEL_H_

#if defined(__GNUG__) && !defined(__APPLE__)
#pragma interface "CamerasPanel.cpp"
#endif

/*!
 * Includes
 */

////@begin includes
#include "wx/xrc/xmlres.h"
#include "wx/treectrl.h"
////@end includes

#include "rectangularobserver.h"
#include "sphericalobserver.h"
#include "rectangularcamera.h"
#include "sphericalcamera.h"

/*!
 * Forward declarations
 */

////@begin forward declarations
class wxTreeCtrl;
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define IDD_CAMERASPANEL 10044
#define SYMBOL_CCAMERASPANEL_STYLE 0
#define SYMBOL_CCAMERASPANEL_TITLE _("Cameras")
#define SYMBOL_CCAMERASPANEL_IDNAME IDD_CAMERASPANEL
#define SYMBOL_CCAMERASPANEL_SIZE wxDefaultSize
#define SYMBOL_CCAMERASPANEL_POSITION wxDefaultPosition
////@end control identifiers

/*!
 * Compatibility
 */

#ifndef wxCLOSE_BOX
#define wxCLOSE_BOX 0x1000
#endif
#ifndef wxFIXED_MINSIZE
#define wxFIXED_MINSIZE 0
#endif

/*!
 * CCamerasPanel class declaration
 */

class CCamerasPanel: public wxPanel
{    
    DECLARE_DYNAMIC_CLASS( CCamerasPanel )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CCamerasPanel( );
	~CCamerasPanel();
    CCamerasPanel( wxWindow* parent, wxWindowID id = SYMBOL_CCAMERASPANEL_IDNAME, const wxPoint& pos = SYMBOL_CCAMERASPANEL_POSITION, const wxSize& size = SYMBOL_CCAMERASPANEL_SIZE, long style = SYMBOL_CCAMERASPANEL_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CCAMERASPANEL_IDNAME, const wxPoint& pos = SYMBOL_CCAMERASPANEL_POSITION, const wxSize& size = SYMBOL_CCAMERASPANEL_SIZE, long style = SYMBOL_CCAMERASPANEL_STYLE );

    /// Creates the controls and sizers
    void CreateControls();

////@begin CCamerasPanel event handler declarations

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_ADDCAMERA
    void OnAddcameraClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_REMOVECAMERA
    void OnRemovecameraClick( wxCommandEvent& event );

    /// wxEVT_UPDATE_UI event handler for ID_REMOVECAMERA
    void OnRemovecameraUpdate( wxUpdateUIEvent& event );

    /// wxEVT_COMMAND_TREE_ITEM_ACTIVATED event handler for ID_CAMERAS
    void OnCamerasItemActivated( wxTreeEvent& event );

////@end CCamerasPanel event handler declarations

	void OnOrbiterClick( wxCommandEvent& event );
	void OnRectangularClick( wxCommandEvent& event );
    void OnPopupUpdate( wxUpdateUIEvent& event );

////@begin CCamerasPanel member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CCamerasPanel member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin CCamerasPanel member variables
    wxButton* m_addCtrl;
    wxTreeCtrl* m_camerasCtrl;
////@end CCamerasPanel member variables

	void UpdateCameras();
	void UpdateObservers();
	CRectangularObserver * m_rectangularObserver;
	CSphericalObserver * m_sphericalObserver;

	CRectangularObserver * GetRectangularObserver();
	CSphericalObserver * GetSphericalObserver();
};

#endif
    // _CAMERASPANEL_H_
