#pragma once

#include <memory>
#include <schwarzmeier/std.h>
#include "camera.h"

class CChunkDesc
{
public:
	CChunkDesc(void);
	CChunkDesc( const CChunkDesc & original );
	~CChunkDesc(void);

	CChunkDesc & operator=( const CChunkDesc & right_side );

	double GetDuration();
	void SetDuration(double durationTime);

	double GetStartTime();
	void SetStartTime(double startTime);

	double GetEndTime();
	void SetEndTime(double endTime);

	CCamera * GetStartCamera();
	void SetStartCamera( CCamera * startMatrix );

	CCamera * GetEndCamera();
	void SetEndCamera( CCamera * endMatrix );

	virtual xmlNode * Serialize(xmlDoc * pXmlDoc, xmlNode * pXmlNode);
	virtual void Deserialize( xmlDoc * pXmlDoc, xmlNode * pXmlNode );

protected:

	CCamera * m_startCamera;
	CCamera * m_endCamera;

	double m_startTime;		//  simulation time
	double m_endTime;		//  simulation time

	double m_durationTime;	//  animation timespan

	static std::string s_strCameraChunk;
	static std::string s_strStartTime;
	static std::string s_strEndTime;
	static std::string s_strDurationTime;
	static std::string s_strStartCamera;
	static std::string s_strEndCamera;
};
