/////////////////////////////////////////////////////////////////////////////
// Name:        CometPropertiesPnl.cpp
// Purpose:     
// Author:      Jakub Schwarzmeier
// Modified by: 
// Created:     08/15/06 18:28:13
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#if defined(__GNUG__) && !defined(__APPLE__)
#pragma implementation "CometPropertiesPnl.h"
#endif

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

////@begin includes
////@end includes

#include "CometPropertiesPnl.h"
#include "Comet.h"

////@begin XPM images
////@end XPM images

/*!
 * CCometPropertiesPnl type definition
 */

IMPLEMENT_DYNAMIC_CLASS( CCometPropertiesPnl, wxPanel )

/*!
 * CCometPropertiesPnl event table definition
 */

BEGIN_EVENT_TABLE( CCometPropertiesPnl, wxPanel )

////@begin CCometPropertiesPnl event table entries
////@end CCometPropertiesPnl event table entries

END_EVENT_TABLE()

/*!
 * CCometPropertiesPnl constructors
 */

CCometPropertiesPnl::CCometPropertiesPnl( )
{
}

CCometPropertiesPnl::CCometPropertiesPnl( wxWindow* parent, wxWindowID id, const wxPoint& pos, const wxSize& size, long style )
{
    Create(parent, id, pos, size, style);
}

/*!
 * CCometPropertiesPnl creator
 */

bool CCometPropertiesPnl::Create( wxWindow* parent, wxWindowID id, const wxPoint& pos, const wxSize& size, long style )
{
////@begin CCometPropertiesPnl member initialisation
    m_eta = 0;
    m_tau = 0;
    m_a1 = 0;
    m_a2 = 0;
    m_a3 = 0;
    m_modelCtrl = NULL;
////@end CCometPropertiesPnl member initialisation

////@begin CCometPropertiesPnl creation
    SetParent(parent);
    CreateControls();
    GetSizer()->Fit(this);
    GetSizer()->SetSizeHints(this);
    Centre();
////@end CCometPropertiesPnl creation
    return true;
}

/*!
 * Control creation for CCometPropertiesPnl
 */

void CCometPropertiesPnl::CreateControls()
{    
    wxXmlResource::Get()->Load(wxT("xrc/cometproperties.xrc")); 

////@begin CCometPropertiesPnl content construction
    wxXmlResource::Get()->LoadPanel(this, GetParent(), _T("IDD_COMETPROPERTIES"));
    m_modelCtrl = XRCCTRL(*this, "ID_CHOICE", wxChoice);
    // Set validators
    if (FindWindow(XRCID("ID_TEXTCTRL")))
        FindWindow(XRCID("ID_TEXTCTRL"))->SetValidator( wxDoubleValidator(& m_eta) );
    if (FindWindow(XRCID("ID_TEXTCTRL2")))
        FindWindow(XRCID("ID_TEXTCTRL2"))->SetValidator( wxDoubleValidator(& m_tau) );
    if (FindWindow(XRCID("ID_TEXTCTRL1")))
        FindWindow(XRCID("ID_TEXTCTRL1"))->SetValidator( wxDoubleValidator(& m_a1) );
    if (FindWindow(XRCID("ID_TEXTCTRL3")))
        FindWindow(XRCID("ID_TEXTCTRL3"))->SetValidator( wxDoubleValidator(& m_a2) );
    if (FindWindow(XRCID("ID_TEXTCTRL4")))
        FindWindow(XRCID("ID_TEXTCTRL4"))->SetValidator( wxDoubleValidator(& m_a3) );
////@end CCometPropertiesPnl content construction

    // Create custom windows not generated automatically here.
	Comet * comet = wxDynamicCast( GetClientData(), Comet );

	m_modelCtrl->SetSelection( comet->GetModel() );

	m_eta = comet->GetEta();
	m_tau = comet->GetTau();

	m_a1 = comet->GetA1();
	m_a2 = comet->GetA2();
	m_a3 = comet->GetA3();


////@begin CCometPropertiesPnl content initialisation

////@end CCometPropertiesPnl content initialisation
}

/*!
 * Should we show tooltips?
 */

bool CCometPropertiesPnl::ShowToolTips()
{
    return true;
}

/*!
 * Get bitmap resources
 */

wxBitmap CCometPropertiesPnl::GetBitmapResource( const wxString& name )
{
    // Bitmap retrieval
////@begin CCometPropertiesPnl bitmap retrieval
    wxUnusedVar(name);
    return wxNullBitmap;
////@end CCometPropertiesPnl bitmap retrieval
}

/*!
 * Get icon resources
 */

wxIcon CCometPropertiesPnl::GetIconResource( const wxString& name )
{
    // Icon retrieval
////@begin CCometPropertiesPnl icon retrieval
    wxUnusedVar(name);
    return wxNullIcon;
////@end CCometPropertiesPnl icon retrieval
}

bool CCometPropertiesPnl::TransferDataFromWindow()
{
	bool r = wxPanel::TransferDataFromWindow();

	if (r)
	{
		Comet * comet = reinterpret_cast<Comet*>( GetClientData() );

		comet->SetModel( static_cast<Comet::MODEL>( m_modelCtrl->GetSelection() ) );

		comet->SetEta(m_eta);
		comet->SetTau(m_tau);

		comet->SetA1( m_a1 );
		comet->SetA2( m_a2 );
		comet->SetA3( m_a3 );
	}

	return r;
}
