/////////////////////////////////////////////////////////////////////////////
// Name:        CometPropertiesPnl.h
// Purpose:     
// Author:      Jakub Schwarzmeier
// Modified by: 
// Created:     08/15/06 18:28:13
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

#ifndef _COMETPROPERTIESPNL_H_
#define _COMETPROPERTIESPNL_H_

#if defined(__GNUG__) && !defined(__APPLE__)
#pragma interface "CometPropertiesPnl.cpp"
#endif

/*!
 * Includes
 */

////@begin includes
#include "wx/xrc/xmlres.h"
////@end includes

/*!
 * Forward declarations
 */

////@begin forward declarations
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define IDD_COMETPROPERTIES 10032
#define SYMBOL_CCOMETPROPERTIESPNL_STYLE 0
#define SYMBOL_CCOMETPROPERTIESPNL_TITLE _("Comet")
#define SYMBOL_CCOMETPROPERTIESPNL_IDNAME IDD_COMETPROPERTIES
#define SYMBOL_CCOMETPROPERTIESPNL_SIZE wxSize(400, 300)
#define SYMBOL_CCOMETPROPERTIESPNL_POSITION wxDefaultPosition
////@end control identifiers

/*!
 * Compatibility
 */

#ifndef wxCLOSE_BOX
#define wxCLOSE_BOX 0x1000
#endif
#ifndef wxFIXED_MINSIZE
#define wxFIXED_MINSIZE 0
#endif

/*!
 * CCometPropertiesPnl class declaration
 */

class CCometPropertiesPnl: public wxPanel
{    
    DECLARE_DYNAMIC_CLASS( CCometPropertiesPnl )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CCometPropertiesPnl( );
    CCometPropertiesPnl( wxWindow* parent, wxWindowID id = SYMBOL_CCOMETPROPERTIESPNL_IDNAME, const wxPoint& pos = SYMBOL_CCOMETPROPERTIESPNL_POSITION, const wxSize& size = SYMBOL_CCOMETPROPERTIESPNL_SIZE, long style = SYMBOL_CCOMETPROPERTIESPNL_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CCOMETPROPERTIESPNL_IDNAME, const wxPoint& pos = SYMBOL_CCOMETPROPERTIESPNL_POSITION, const wxSize& size = SYMBOL_CCOMETPROPERTIESPNL_SIZE, long style = SYMBOL_CCOMETPROPERTIESPNL_STYLE );

    /// Creates the controls and sizers
    void CreateControls();

////@begin CCometPropertiesPnl event handler declarations

////@end CCometPropertiesPnl event handler declarations

////@begin CCometPropertiesPnl member function declarations

    double GetEta() const { return m_eta ; }
    void SetEta(double value) { m_eta = value ; }

    double GetTau() const { return m_tau ; }
    void SetTau(double value) { m_tau = value ; }

    double GetA() const { return m_a1 ; }
    void SetA(double value) { m_a1 = value ; }

    double GetA2() const { return m_a2 ; }
    void SetA2(double value) { m_a2 = value ; }

    double GetA3() const { return m_a3 ; }
    void SetA3(double value) { m_a3 = value ; }

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CCometPropertiesPnl member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin CCometPropertiesPnl member variables
    wxChoice* m_modelCtrl;
    double m_eta;
    double m_tau;
    double m_a1;
    double m_a2;
    double m_a3;
////@end CCometPropertiesPnl member variables

	virtual bool TransferDataFromWindow();
};

#endif
    // _COMETPROPERTIESPNL_H_
