#ifndef __EXTENDEDBODY__
#define __EXTENDEDBODY__

#include "body.h"

class ExtendedBody: public Body
{
public:

	ExtendedBody( );
	ExtendedBody( const ExtendedBody & original );
	virtual ~ExtendedBody() {};

	ExtendedBody & operator=( const ExtendedBody & right_side );

	virtual xmlNode * Serialize(xmlDoc * pXmlDoc, xmlNode * pXmlNode);
	virtual void Deserialize( xmlDoc * pXmlDoc, xmlNode * pXmlNode );

	//  Get longitude (right ascension), latitude (declination) and prime meridian for
	//  current time of simulation.
	double GetPoleLongitude();
	double GetPoleLatitude();
	double GetPM();
	
	double GetRadius();

	std::string GetTexture();
	void SetTexture(std::string texture);

protected:

	static void Assign2(Body * body, Body * right_side);

	std::string m_texture;

	static const double s_eps;

	static std::string s_strTexture;

	DECLARE_DYNAMIC_CLASS (ExtendedBody)
};

#endif // __EXTENDEDBODY__