/////////////////////////////////////////////////////////////////////////////
// Name:        ExtendedBodyPropertiesPnl.cpp
// Purpose:     
// Author:      Jakub Schwarzmeier
// Modified by: 
// Created:     08/29/06 17:31:29
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#if defined(__GNUG__) && !defined(__APPLE__)
#pragma implementation "ExtendedBodyPropertiesPnl.h"
#endif

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

////@begin includes
////@end includes

#include "ExtendedBodyPropertiesPnl.h"
#include "ExtendedBody.h"

////@begin XPM images
////@end XPM images

/*!
 * CExtendedBodyPropertiesPnl type definition
 */

IMPLEMENT_DYNAMIC_CLASS( CExtendedBodyPropertiesPnl, wxPanel )

/*!
 * CExtendedBodyPropertiesPnl event table definition
 */

BEGIN_EVENT_TABLE( CExtendedBodyPropertiesPnl, wxPanel )

////@begin CExtendedBodyPropertiesPnl event table entries
    EVT_BUTTON( XRCID("ID_BUTTON"), CExtendedBodyPropertiesPnl::OnButtonClick )

////@end CExtendedBodyPropertiesPnl event table entries

END_EVENT_TABLE()

/*!
 * CExtendedBodyPropertiesPnl constructors
 */

CExtendedBodyPropertiesPnl::CExtendedBodyPropertiesPnl( )
{
}

CExtendedBodyPropertiesPnl::CExtendedBodyPropertiesPnl( wxWindow* parent, wxWindowID id, const wxPoint& pos, const wxSize& size, long style )
{
    Create(parent, id, pos, size, style);
}

/*!
 * CExtendedBodyPropertiesPnl creator
 */

bool CExtendedBodyPropertiesPnl::Create( wxWindow* parent, wxWindowID id, const wxPoint& pos, const wxSize& size, long style )
{
////@begin CExtendedBodyPropertiesPnl member initialisation
////@end CExtendedBodyPropertiesPnl member initialisation

////@begin CExtendedBodyPropertiesPnl creation
    SetParent(parent);
    CreateControls();
    GetSizer()->Fit(this);
    GetSizer()->SetSizeHints(this);
    Centre();
////@end CExtendedBodyPropertiesPnl creation
    return true;
}

/*!
 * Control creation for CExtendedBodyPropertiesPnl
 */

void CExtendedBodyPropertiesPnl::CreateControls()
{    
    wxXmlResource::Get()->Load(wxT("xrc/extendedbodyproperties.xrc")); 

////@begin CExtendedBodyPropertiesPnl content construction
    wxXmlResource::Get()->LoadPanel(this, GetParent(), _T("IDD_EXTENDEDBODY"));
    // Set validators
    if (FindWindow(XRCID("ID_TEXTURE")))
        FindWindow(XRCID("ID_TEXTURE"))->SetValidator( wxGenericValidator(& m_texture) );
////@end CExtendedBodyPropertiesPnl content construction

	ExtendedBody * extBody = wxDynamicCast( GetClientData(), ExtendedBody );
	m_texture = extBody->GetTexture().c_str();

    // Create custom windows not generated automatically here.

////@begin CExtendedBodyPropertiesPnl content initialisation

////@end CExtendedBodyPropertiesPnl content initialisation
}

/*!
 * Should we show tooltips?
 */

bool CExtendedBodyPropertiesPnl::ShowToolTips()
{
    return true;
}

/*!
 * Get bitmap resources
 */

wxBitmap CExtendedBodyPropertiesPnl::GetBitmapResource( const wxString& name )
{
    // Bitmap retrieval
////@begin CExtendedBodyPropertiesPnl bitmap retrieval
    wxUnusedVar(name);
    return wxNullBitmap;
////@end CExtendedBodyPropertiesPnl bitmap retrieval
}

/*!
 * Get icon resources
 */

wxIcon CExtendedBodyPropertiesPnl::GetIconResource( const wxString& name )
{
    // Icon retrieval
////@begin CExtendedBodyPropertiesPnl icon retrieval
    wxUnusedVar(name);
    return wxNullIcon;
////@end CExtendedBodyPropertiesPnl icon retrieval
}
/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON
 */

void CExtendedBodyPropertiesPnl::OnButtonClick( wxCommandEvent& event )
{
	wxFileDialog fileDialog(this, wxFileSelectorPromptStr, wxEmptyString, wxEmptyString,
            wxFileSelectorDefaultWildcardStr, wxFD_DEFAULT_STYLE | wxFILE_MUST_EXIST );

	fileDialog.CentreOnParent();
	if ( fileDialog.ShowModal() == wxID_OK )
	{
		m_texture = fileDialog.GetPath();

		TransferDataToWindow();
	}
}

bool CExtendedBodyPropertiesPnl::TransferDataFromWindow()
{
	bool r = wxPanel::TransferDataFromWindow();

	if (r)
	{
		ExtendedBody * extBody = wxDynamicCast( GetClientData(), ExtendedBody );
		
		wxFileName fn( m_texture );
		fn.MakeAbsolute();
        
		if (!m_texture.IsEmpty())	extBody->SetTexture( fn.GetFullPath().c_str() );
	}

	return r;
}
