#pragma once
#include "bodytarget.h"

class CExtendedBodyTarget :
	public CBodyTarget
{
public:
	CExtendedBodyTarget(Body * body, CVisualization * visualization);
	virtual ~CExtendedBodyTarget(void);

	virtual void Render();
	virtual void OnContextTerminate();

	virtual double GetFurthermostDistance();
	virtual double GetNearestDistance();
	virtual bool IsLarge();
	virtual double GetSize();

	virtual JakubSchwarzmeier::Std::Graphics::RotationMatrix GetObjectInEye();

protected:

	void PrintOSD();
	void RenderRotationAxis();
	void RenderObjectCentricSystem();

	double m_radius;
	GLuint m_iTexture;
};
