#include "stdafx.h"

#include "IrregularBody.h"

IMPLEMENT_DYNAMIC_CLASS (IrregularBody, ExtendedBody)

IrregularBody::IrregularBody()
{
    //  dispatch
	mapDispatch.insert( MAPDISPATCH::value_type( this->GetClassInfo() , Assign2 ) );
}

IrregularBody::IrregularBody( const IrregularBody & original )
{
	operator=( original );
}

/* static */
void IrregularBody::Assign2(Body * body, Body * right_side) 
{
	//  retype
	IrregularBody * comet_left = dynamic_cast<IrregularBody*>( body );
	IrregularBody * comet_right = dynamic_cast<IrregularBody*>( right_side );
	comet_left->operator=( *comet_right );
}

IrregularBody & IrregularBody::operator=( const IrregularBody & right_side )
{
	if ( &right_side == this )  return (*this);

	ExtendedBody::operator=( right_side );

	m_model = right_side.m_model;

	return *this;
}

xmlNode * IrregularBody::Serialize(xmlDoc * pXmlDoc, xmlNode * pXmlNode)
{
	//  call ancestor's implementation
	xmlNode * pBodyNode = ExtendedBody::Serialize(pXmlDoc, pXmlNode);		

	//  texture
	xmlNode * p3dModelNode = xmlNewNode( NULL, (const xmlChar *)s_str3dModel.c_str() );
	xmlAddChild( pBodyNode, p3dModelNode );

	wxFileName modelFile( m_model.c_str() );
	modelFile.MakeRelativeTo( wxFileName::GetCwd() );

	SetTextNode( pXmlDoc, p3dModelNode, modelFile.GetFullPath().c_str() );

	return pBodyNode;
}


void IrregularBody::Deserialize(xmlDoc * pXmlDoc, xmlNode * pXmlNode )
{
	ExtendedBody::Deserialize(pXmlDoc, pXmlNode);		//  call ancestor
	
	//  retrieve texture
	std::string strModelXpath( s_str3dModel );
	strModelXpath += _T("/text()");
	std::string strModel = GetXPathResponse( pXmlDoc, pXmlNode, strModelXpath );

	wxFileName modelFile( strModel.c_str() );
	modelFile.MakeAbsolute( );

	m_model = modelFile.GetFullPath().c_str();
}

std::string IrregularBody::GetModel()
{
	return m_model;
}

void IrregularBody::SetModel(std::string model)
{
	m_model = model;
}

std::string IrregularBody::s_str3dModel( _T("threedmodel") );

