/////////////////////////////////////////////////////////////////////////////
// Name:        IrregularBodyPropertiesPnl.cpp
// Purpose:     
// Author:      Jakub Schwarzmeier
// Modified by: 
// Created:     08/30/06 09:37:56
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#if defined(__GNUG__) && !defined(__APPLE__)
#pragma implementation "IrregularBodyPropertiesPnl.h"
#endif

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

////@begin includes
////@end includes

#include "IrregularBodyPropertiesPnl.h"
#include "IrregularBody.h"

////@begin XPM images
////@end XPM images

/*!
 * CIrregularBodyPropertiesPnl type definition
 */

IMPLEMENT_DYNAMIC_CLASS( CIrregularBodyPropertiesPnl, wxPanel )

/*!
 * CIrregularBodyPropertiesPnl event table definition
 */

BEGIN_EVENT_TABLE( CIrregularBodyPropertiesPnl, wxPanel )

////@begin CIrregularBodyPropertiesPnl event table entries
    EVT_BUTTON( XRCID("ID_BROWSE"), CIrregularBodyPropertiesPnl::OnBrowseClick )

////@end CIrregularBodyPropertiesPnl event table entries

END_EVENT_TABLE()

/*!
 * CIrregularBodyPropertiesPnl constructors
 */

CIrregularBodyPropertiesPnl::CIrregularBodyPropertiesPnl( )
{
}

CIrregularBodyPropertiesPnl::CIrregularBodyPropertiesPnl( wxWindow* parent, wxWindowID id, const wxPoint& pos, const wxSize& size, long style )
{
    Create(parent, id, pos, size, style);
}

/*!
 * CIrregularBodyPropertiesPnl creator
 */

bool CIrregularBodyPropertiesPnl::Create( wxWindow* parent, wxWindowID id, const wxPoint& pos, const wxSize& size, long style )
{
////@begin CIrregularBodyPropertiesPnl member initialisation
////@end CIrregularBodyPropertiesPnl member initialisation

////@begin CIrregularBodyPropertiesPnl creation
    SetParent(parent);
    CreateControls();
    GetSizer()->Fit(this);
    GetSizer()->SetSizeHints(this);
    Centre();
////@end CIrregularBodyPropertiesPnl creation
    return true;
}

/*!
 * Control creation for CIrregularBodyPropertiesPnl
 */

void CIrregularBodyPropertiesPnl::CreateControls()
{    
    wxXmlResource::Get()->Load(wxT("xrc/irregularbodyproperties.xrc")); 

////@begin CIrregularBodyPropertiesPnl content construction
    wxXmlResource::Get()->LoadPanel(this, GetParent(), _T("IDD_IRREGULARBODYPROPERTIES"));
    // Set validators
    if (FindWindow(XRCID("ID_3DMODEL")))
        FindWindow(XRCID("ID_3DMODEL"))->SetValidator( wxNotNullValidator(& m_model, _T("Please enter the filename of model.") ) );
////@end CIrregularBodyPropertiesPnl content construction

	IrregularBody * extBody = wxDynamicCast( GetClientData(), IrregularBody );
	m_model = extBody->GetModel().c_str();

    // Create custom windows not generated automatically here.

////@begin CIrregularBodyPropertiesPnl content initialisation

////@end CIrregularBodyPropertiesPnl content initialisation
}

/*!
 * Should we show tooltips?
 */

bool CIrregularBodyPropertiesPnl::ShowToolTips()
{
    return true;
}

/*!
 * Get bitmap resources
 */

wxBitmap CIrregularBodyPropertiesPnl::GetBitmapResource( const wxString& name )
{
    // Bitmap retrieval
////@begin CIrregularBodyPropertiesPnl bitmap retrieval
    wxUnusedVar(name);
    return wxNullBitmap;
////@end CIrregularBodyPropertiesPnl bitmap retrieval
}

/*!
 * Get icon resources
 */

wxIcon CIrregularBodyPropertiesPnl::GetIconResource( const wxString& name )
{
    // Icon retrieval
////@begin CIrregularBodyPropertiesPnl icon retrieval
    wxUnusedVar(name);
    return wxNullIcon;
////@end CIrregularBodyPropertiesPnl icon retrieval
}
/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BROWSE
 */

void CIrregularBodyPropertiesPnl::OnBrowseClick( wxCommandEvent& event )
{
	wxFileDialog fileDialog(this, wxFileSelectorPromptStr, wxEmptyString, wxEmptyString,
                wxFileSelectorDefaultWildcardStr, wxFD_DEFAULT_STYLE | wxFILE_MUST_EXIST );

	fileDialog.CentreOnParent();
	if ( fileDialog.ShowModal() == wxID_OK )
	{
		m_model = fileDialog.GetPath();

		TransferDataToWindow();
	}
}

bool CIrregularBodyPropertiesPnl::TransferDataFromWindow()
{
	bool r = wxPanel::TransferDataFromWindow();

	if (r)
	{
		IrregularBody * extBody = wxDynamicCast( GetClientData(), IrregularBody );
		
		wxFileName fn( m_model );
		fn.MakeAbsolute();

		if (!m_model.IsEmpty())	extBody->SetModel( fn.GetFullPath().c_str() );
	}

	return r;
}