/////////////////////////////////////////////////////////////////////////////
// Name:        OrbiterCameraDlg.h
// Purpose:     
// Author:      Jakub Schwarzmeier
// Modified by: 
// Created:     08/20/06 18:54:47
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

#ifndef _ORBITERCAMERADLG_H_
#define _ORBITERCAMERADLG_H_

#if defined(__GNUG__) && !defined(__APPLE__)
#pragma interface "OrbiterCameraDlg.cpp"
#endif

/*!
 * Includes
 */

////@begin includes
#include "wx/xrc/xmlres.h"
#include "wx/valgen.h"
////@end includes

#include "ChunkDesc.h"
#include <schwarzmeier/wx.h>

/*!
 * Forward declarations
 */

////@begin forward declarations
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define IDD_ORBITERCAMERA 10047
#define SYMBOL_CORBITERCAMERADLG_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX
#define SYMBOL_CORBITERCAMERADLG_TITLE _("Orbiter Camera")
#define SYMBOL_CORBITERCAMERADLG_IDNAME IDD_ORBITERCAMERA
#define SYMBOL_CORBITERCAMERADLG_SIZE wxSize(400, 300)
#define SYMBOL_CORBITERCAMERADLG_POSITION wxDefaultPosition
////@end control identifiers

/*!
 * Compatibility
 */

#ifndef wxCLOSE_BOX
#define wxCLOSE_BOX 0x1000
#endif
#ifndef wxFIXED_MINSIZE
#define wxFIXED_MINSIZE 0
#endif

/*!
 * COrbiterCameraDlg class declaration
 */

class COrbiterCameraDlg: public wxDialog
{    
    DECLARE_DYNAMIC_CLASS( COrbiterCameraDlg )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    COrbiterCameraDlg( );
    COrbiterCameraDlg( wxWindow* parent, wxWindowID id = SYMBOL_CORBITERCAMERADLG_IDNAME, const wxString& caption = SYMBOL_CORBITERCAMERADLG_TITLE, const wxPoint& pos = SYMBOL_CORBITERCAMERADLG_POSITION, const wxSize& size = SYMBOL_CORBITERCAMERADLG_SIZE, long style = SYMBOL_CORBITERCAMERADLG_STYLE );
    ~COrbiterCameraDlg( );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CORBITERCAMERADLG_IDNAME, const wxString& caption = SYMBOL_CORBITERCAMERADLG_TITLE, const wxPoint& pos = SYMBOL_CORBITERCAMERADLG_POSITION, const wxSize& size = SYMBOL_CORBITERCAMERADLG_SIZE, long style = SYMBOL_CORBITERCAMERADLG_STYLE );

    /// Creates the controls and sizers
    void CreateControls();

////@begin COrbiterCameraDlg event handler declarations

    /// wxEVT_PAINT event handler for IDD_ORBITERCAMERA
    void OnPaint( wxPaintEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_GETSTARTING
    void OnGetstartingClick( wxCommandEvent& event );

    /// wxEVT_UPDATE_UI event handler for ID_GETSTARTING
    void OnUpdateUI( wxUpdateUIEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_APPLYSTARTING
    void OnApplystartingClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_GETENDING
    void OnGetendingClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_APPLYENDING
    void OnApplyendingClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for wxID_OK
    void OnOkClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for wxID_CANCEL
    void OnCancelClick( wxCommandEvent& event );

////@end COrbiterCameraDlg event handler declarations

////@begin COrbiterCameraDlg member function declarations

    double GetAnimationDuration() const { return m_animationDuration ; }
    void SetAnimationDuration(double value) { m_animationDuration = value ; }

    double GetStartTime() const { return m_startTime ; }
    void SetStartTime(double value) { m_startTime = value ; }

    double GetEndTime() const { return m_endTime ; }
    void SetEndTime(double value) { m_endTime = value ; }

    wxString GetStartMatrix() const { return m_startMatrix ; }
    void SetStartMatrix(wxString value) { m_startMatrix = value ; }

    wxString GetEndMatrix() const { return m_endMatrix ; }
    void SetEndMatrix(wxString value) { m_endMatrix = value ; }

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end COrbiterCameraDlg member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin COrbiterCameraDlg member variables
    double m_animationDuration;
    double m_startTime;
    double m_endTime;
    wxString m_startMatrix;
    wxString m_endMatrix;
////@end COrbiterCameraDlg member variables

	bool m_bNewChunk;
	CChunkDesc * m_localChunkDesc;
	static std::string s_strSprintf;

	JakubSchwarzmeier::wx::COpenGLCanvas * GetActiveView();
};

#endif
    // _ORBITERCAMERADLG_H_
