/////////////////////////////////////////////////////////////////////////////
// Name:        CPhaethonApp.cpp
// Purpose:     
// Author:      Jakub Schwarzmeier
// Modified by: 
// Created:     08/11/06 09:44:06
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#if defined(__GNUG__) && !defined(__APPLE__)
#pragma implementation "PhaethonApp.h"
#endif

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

////@begin includes
////@end includes

#include "PhaethonApp.h"
#include "PhaethonView.h"
#include "PhaethonDoc.h"

////@begin XPM images
////@end XPM images

/*!
 * Application instance implementation
 */

////@begin implement app
IMPLEMENT_APP( CPhaethonApp )
////@end implement app

/*!
 * CPhaethonApp type definition
 */

IMPLEMENT_CLASS( CPhaethonApp, JakubSchwarzmeier::wx::CApp )

/*!
 * CPhaethonApp event table definition
 */

BEGIN_EVENT_TABLE( CPhaethonApp, wxApp )

////@begin CPhaethonApp event table entries
////@end CPhaethonApp event table entries

END_EVENT_TABLE()

/*!
 * Constructor for CPhaethonApp
 */

CPhaethonApp::CPhaethonApp()
{
////@begin CPhaethonApp member initialisation
////@end CPhaethonApp member initialisation
}

/*!
 * Initialisation for CPhaethonApp
 */

bool CPhaethonApp::OnInit()
{    

	if ( CApp::OnInit() == false)	return false;

	// Load the file history

	// We're using wxConfig's "create-on-demand" feature: it will create the
	// config object when it's used for the first time. It has a number of
	// advantages compared with explicitly creating our wxConfig:
	//  1) we don't pay for it if we don't use it
	//  2) there is no danger to create it twice

	wxConfigBase * pConfig = wxConfigBase::Get();
	m_docManager->FileHistoryLoad( *pConfig );

	//// Create a template relating drawing documents to their views
	wxDocTemplate * pDocTemplate;
	pDocTemplate = new wxDocTemplate(m_docManager, _T("Phaethon File"), _T("*.xml"), 
		_T(""), _T("xml"), _T("Phaethon Doc"), _T("Phaethon View"),
		CLASSINFO(CPhaethonDoc), CLASSINFO(CPhaethonView));
	m_docManager->AssociateTemplate( pDocTemplate );

////@begin CPhaethonApp initialisation
// Remove the comment markers above and below this block
// to make permanent changes to the code.

#if wxUSE_XPM
    wxImage::AddHandler( new wxXPMHandler );
#endif
#if wxUSE_LIBPNG
    wxImage::AddHandler( new wxPNGHandler );
#endif
#if wxUSE_LIBJPEG
    wxImage::AddHandler( new wxJPEGHandler );
#endif
#if wxUSE_GIF
    wxImage::AddHandler( new wxGIFHandler );
#endif

////@end CPhaethonApp initialisation

    // Initialize all the XRC handlers. Always required (unless you feel like
    // going through and initializing a handler of each control type you will
    // be using (ie initialize the spinctrl handler, initialize the textctrl
    // handler). However, if you are only using a few control types, it will
    // save some space to only initialize the ones you will be using. See
    // wxXRC docs for details.
	wxXmlResource::Get()->InitAllHandlers();

	//  Create main app window
	m_frame = new CMainFrame( NULL, NULL, ID_MAINFRAME );
	SetTopWindow( m_frame ); 
	m_frame->Show(true);

    return true;
}

/*!
 * Cleanup for CPhaethonApp
 */
int CPhaethonApp::OnExit()
{    
	xmlCleanupParser(); 

	wxConfigBase * pConfig = wxConfigBase::Get();
    m_docManager->FileHistorySave( *pConfig );

	return JakubSchwarzmeier::wx::CApp::OnExit();
}

CMainFrame * CPhaethonApp::GetMainFrame()
{
	return static_cast<CMainFrame*>( m_frame );
}

CPhaethonDoc * CPhaethonApp::GetDocument()
{
	return reinterpret_cast<CPhaethonDoc*>( GetDocManager()->GetCurrentDocument() );
}
