// NostradamusDoc.h : interface of the CPhaethonDoc class
//

#ifndef __RECOGNITADOC_H__
#define __RECOGNITADOC_H__

#include "simulation.h"
#include "visualization.h"

class CVisualization;

class CPhaethonDoc: public wxDocument
{
public: 
	CPhaethonDoc();
	virtual ~CPhaethonDoc();

public:

	virtual bool OnCreate(const wxString& path, long flags);
	virtual bool Close();
	
	virtual bool OnOpenDocument(const wxString& filename);
	virtual bool OnSaveDocument(const wxString& filename);
	virtual bool OnSerialize( JakubSchwarzmeier::wx::CSerializeReaderWriter * dir );


	Simulation * GetSimulation();
	void SetSimulation( Simulation * sim );

	CVisualization * GetVisualization();

protected:

	Simulation * m_simulation;
	CVisualization * m_visualization;

	static std::string s_strPhaethon;

	DECLARE_EVENT_TABLE()
	DECLARE_DYNAMIC_CLASS(CPhaethonDoc)
};

#endif //  __RECOGNITADOC_H__
