/////////////////////////////////////////////////////////////////////////////
// Name:        SettingsDlg.h
// Purpose:     
// Author:      Jakub Schwarzmeier
// Modified by: 
// Created:     09/17/06 15:33:07
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

#ifndef _SETTINGSDLG_H_
#define _SETTINGSDLG_H_

#if defined(__GNUG__) && !defined(__APPLE__)
#pragma interface "SettingsDlg.cpp"
#endif

/*!
 * Includes
 */

////@begin includes
#include "wx/xrc/xmlres.h"
////@end includes

/*!
 * Forward declarations
 */

////@begin forward declarations
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define IDD_SETTINGS 10092
#define SYMBOL_CSETTINGSDLG_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX
#define SYMBOL_CSETTINGSDLG_TITLE _("Settings")
#define SYMBOL_CSETTINGSDLG_IDNAME IDD_SETTINGS
#define SYMBOL_CSETTINGSDLG_SIZE wxSize(400, 300)
#define SYMBOL_CSETTINGSDLG_POSITION wxDefaultPosition
////@end control identifiers

/*!
 * Compatibility
 */

#ifndef wxCLOSE_BOX
#define wxCLOSE_BOX 0x1000
#endif
#ifndef wxFIXED_MINSIZE
#define wxFIXED_MINSIZE 0
#endif

/*!
 * CSettingsDlg class declaration
 */

class CSettingsDlg: public wxDialog
{    
    DECLARE_DYNAMIC_CLASS( CSettingsDlg )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CSettingsDlg( );
    CSettingsDlg( wxWindow* parent, wxWindowID id = SYMBOL_CSETTINGSDLG_IDNAME, const wxString& caption = SYMBOL_CSETTINGSDLG_TITLE, const wxPoint& pos = SYMBOL_CSETTINGSDLG_POSITION, const wxSize& size = SYMBOL_CSETTINGSDLG_SIZE, long style = SYMBOL_CSETTINGSDLG_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CSETTINGSDLG_IDNAME, const wxString& caption = SYMBOL_CSETTINGSDLG_TITLE, const wxPoint& pos = SYMBOL_CSETTINGSDLG_POSITION, const wxSize& size = SYMBOL_CSETTINGSDLG_SIZE, long style = SYMBOL_CSETTINGSDLG_STYLE );

    /// Creates the controls and sizers
    void CreateControls();

////@begin CSettingsDlg event handler declarations

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for wxID_OK
    void OnOkClick( wxCommandEvent& event );

////@end CSettingsDlg event handler declarations

////@begin CSettingsDlg member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CSettingsDlg member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin CSettingsDlg member variables
    wxCheckBox* m_showOSDCtrl;
    wxCheckBox* m_autoUnitsCtrl;
    wxCheckBox* m_rotationAxisCtrl;
    wxCheckBox* m_bodyCentricFabricCtrl;
    wxCheckBox* m_drawTrajectoriesCtrl;
////@end CSettingsDlg member variables

	bool GetShowOsd();
	bool GetAutoUnits();
	bool GetRotationAxis();
	bool GetBodycentricFabric();
	bool GetDrawTrajectories();

	void SetShowOsd(bool b);
	void SetAutoUnits(bool b);
	void SetRotationAxis(bool b);
	void SetBodycentricFabric(bool b);
	void SetDrawTrajectories(bool b);

protected:

	static wxString m_sShowOsd;
	static wxString m_sAutoUnits;
	static wxString m_sRotationAxis;
	static wxString m_sBodycentricFabric;
	static wxString m_sDrawTrajectories;

	static wxCriticalSection m_csMTSafe;
};

#endif
    // _SETTINGSDLG_H_
