#pragma once

#include "rectangularcamera.h"
#include <schwarzmeier/std.h>

class CSphericalCamera :
	public CRectangularCamera
{
public:
	CSphericalCamera();
	virtual ~CSphericalCamera(void);

	CSphericalCamera( const CSphericalCamera & original );
	CSphericalCamera & operator=( const CSphericalCamera & right_side );

	virtual void ChangeLatitude( double angle );
	virtual void ChangeLongitude( double angle );
	virtual void ChangeDistance( double distance );

	virtual void SetLatitude( double angle );
	virtual void SetLongitude( double angle );
	virtual void SetDistance( double distance );

	double GetLatitude();
	double GetLongitude();
	double GetDistance();

	virtual xmlNode * Serialize(xmlDoc * pXmlDoc, xmlNode * pXmlNode);
	virtual void Deserialize( xmlDoc * pXmlDoc, xmlNode * pXmlNode );

	virtual void Update();

protected:

	JakubSchwarzmeier::Std::Math::Quaternion<> m_longitude, m_latitude;
	double m_distance;

	static void Assign2(CCamera * camera, CCamera * right_side);

	static std::string s_strDistance;
	static std::string s_strLongitude;
	static std::string s_strLatitude;

	DECLARE_DYNAMIC_CLASS (CSphericalCamera)
};
