/////////////////////////////////////////////////////////////////////////////
// Name:        SpiceFilesDlg.h
// Purpose:     
// Author:      Jakub Schwarzmeier
// Modified by: 
// Created:     08/11/06 16:39:09
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

#ifndef _SPICEFILESDLG_H_
#define _SPICEFILESDLG_H_

#if defined(__GNUG__) && !defined(__APPLE__)
#pragma interface "SpiceFilesDlg.cpp"
#endif

/*!
 * Includes
 */

////@begin includes
#include "wx/xrc/xmlres.h"
#include "wx/listctrl.h"
////@end includes

/*!
 * Forward declarations
 */

////@begin forward declarations
class wxListCtrl;
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define IDD_SPICEFILES 10014
#define SYMBOL_CSPICEFILESDLG_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX
#define SYMBOL_CSPICEFILESDLG_TITLE _("SPICE Files")
#define SYMBOL_CSPICEFILESDLG_IDNAME IDD_SPICEFILES
#define SYMBOL_CSPICEFILESDLG_SIZE wxSize(400, 300)
#define SYMBOL_CSPICEFILESDLG_POSITION wxDefaultPosition
////@end control identifiers

/*!
 * Compatibility
 */

#ifndef wxCLOSE_BOX
#define wxCLOSE_BOX 0x1000
#endif
#ifndef wxFIXED_MINSIZE
#define wxFIXED_MINSIZE 0
#endif

/*!
 * CSpiceFilesDlg class declaration
 */

class CSpiceFilesDlg: public wxDialog
{    
    DECLARE_DYNAMIC_CLASS( CSpiceFilesDlg )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CSpiceFilesDlg( );
    CSpiceFilesDlg( wxWindow* parent, wxWindowID id = SYMBOL_CSPICEFILESDLG_IDNAME, const wxString& caption = SYMBOL_CSPICEFILESDLG_TITLE, const wxPoint& pos = SYMBOL_CSPICEFILESDLG_POSITION, const wxSize& size = SYMBOL_CSPICEFILESDLG_SIZE, long style = SYMBOL_CSPICEFILESDLG_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CSPICEFILESDLG_IDNAME, const wxString& caption = SYMBOL_CSPICEFILESDLG_TITLE, const wxPoint& pos = SYMBOL_CSPICEFILESDLG_POSITION, const wxSize& size = SYMBOL_CSPICEFILESDLG_SIZE, long style = SYMBOL_CSPICEFILESDLG_STYLE );

    /// Creates the controls and sizers
    void CreateControls();

////@begin CSpiceFilesDlg event handler declarations

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_ADD
    void OnAddClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_REMOVE
    void OnRemoveClick( wxCommandEvent& event );

    /// wxEVT_UPDATE_UI event handler for ID_REMOVE
    void OnRemoveUpdate( wxUpdateUIEvent& event );

////@end CSpiceFilesDlg event handler declarations

////@begin CSpiceFilesDlg member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CSpiceFilesDlg member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin CSpiceFilesDlg member variables
    wxListCtrl* m_list;
////@end CSpiceFilesDlg member variables
};

#endif
    // _SPICEFILESDLG_H_
