// RecognitaView.h : interface of the CThreedView class
//

#ifndef __RC_THREEDCANVAS_
#define __RC_THREEDCANVAS_

#include "PhaethonDoc.h"
#include "Visualization.h"

class CPhaethonDoc;
class CVisualization;

class CThreedCanvas: public JakubSchwarzmeier::wx::COpenGLCanvas
{
// Overrides
public:

	CThreedCanvas();	//  for two step construction
	CThreedCanvas(wxWindow *parent);
	virtual void Create(wxWindow *parent, bool bDeserialize = false);
	virtual bool OnSerialize( JakubSchwarzmeier::wx::CSerializeReaderWriter * dir );

	const CFrustum * GetFrustum();

	virtual void ForceReRender();

	void AcquireRendering();
	void ReleaseRendering();

	void SetAnimation(bool active);

protected:

	void OnKeyDown(wxKeyEvent& event);
	CPhaethonDoc * m_pDocument;
	CVisualization * m_pVisualization;

	virtual void OnRender();
	virtual void PreRender();
	virtual void RenderFinished();
	virtual void OnContextTerminate();

	void Draw3DGrid();

	CFrustum m_frustum;

	wxCriticalSection m_csRendering;

	bool m_bAnimationActive;
	wxCondition m_condVideo;
	wxMutex m_mutex;

	DECLARE_EVENT_TABLE()
    DECLARE_DYNAMIC_CLASS(CThreedCanvas)
};

#endif  //  __RC_THREEDCANVAS_