/////////////////////////////////////////////////////////////////////////////
// Name:        VisualizationSettingsDlg.h
// Purpose:     
// Author:      Jakub Schwarzmeier
// Modified by: 
// Created:     08/21/06 19:41:01
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

#ifndef _VISUALIZATIONSETTINGSDLG_H_
#define _VISUALIZATIONSETTINGSDLG_H_

#if defined(__GNUG__) && !defined(__APPLE__)
#pragma interface "VisualizationSettingsDlg.cpp"
#endif

/*!
 * Includes
 */

////@begin includes
#include "wx/xrc/xmlres.h"
#include "wx/calctrl.h"
#include "wx/valgen.h"
////@end includes

#include <schwarzmeier/astronomy.h>

/*!
 * Forward declarations
 */

////@begin forward declarations
class wxCalendarCtrl;
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_DIALOG 10039
#define SYMBOL_CVISUALIZATIONSETTINGSDLG_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX
#define SYMBOL_CVISUALIZATIONSETTINGSDLG_TITLE _("Settings")
#define SYMBOL_CVISUALIZATIONSETTINGSDLG_IDNAME ID_DIALOG
#define SYMBOL_CVISUALIZATIONSETTINGSDLG_SIZE wxSize(400, 300)
#define SYMBOL_CVISUALIZATIONSETTINGSDLG_POSITION wxDefaultPosition
////@end control identifiers

/*!
 * Compatibility
 */

#ifndef wxCLOSE_BOX
#define wxCLOSE_BOX 0x1000
#endif
#ifndef wxFIXED_MINSIZE
#define wxFIXED_MINSIZE 0
#endif

/*!
 * CVisualizationSettingsDlg class declaration
 */

class CVisualizationSettingsDlg: public wxDialog
{    
    DECLARE_DYNAMIC_CLASS( CVisualizationSettingsDlg )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CVisualizationSettingsDlg( );
    CVisualizationSettingsDlg( wxWindow* parent, wxWindowID id = SYMBOL_CVISUALIZATIONSETTINGSDLG_IDNAME, const wxString& caption = SYMBOL_CVISUALIZATIONSETTINGSDLG_TITLE, const wxPoint& pos = SYMBOL_CVISUALIZATIONSETTINGSDLG_POSITION, const wxSize& size = SYMBOL_CVISUALIZATIONSETTINGSDLG_SIZE, long style = SYMBOL_CVISUALIZATIONSETTINGSDLG_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CVISUALIZATIONSETTINGSDLG_IDNAME, const wxString& caption = SYMBOL_CVISUALIZATIONSETTINGSDLG_TITLE, const wxPoint& pos = SYMBOL_CVISUALIZATIONSETTINGSDLG_POSITION, const wxSize& size = SYMBOL_CVISUALIZATIONSETTINGSDLG_SIZE, long style = SYMBOL_CVISUALIZATIONSETTINGSDLG_STYLE );

    /// Creates the controls and sizers
    void CreateControls();

////@begin CVisualizationSettingsDlg event handler declarations

    /// wxEVT_UPDATE_UI event handler for ID_CUSTOM_COORD
    void OnCustomCoordUpdate( wxUpdateUIEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for wxID_OK
    void OnOkClick( wxCommandEvent& event );

////@end CVisualizationSettingsDlg event handler declarations

////@begin CVisualizationSettingsDlg member function declarations

    JakubSchwarzmeier::Astronomy::CDateTime GetTimeEt() const { return m_timeEt ; }
    void SetTimeEt(JakubSchwarzmeier::Astronomy::CDateTime value) { m_timeEt = value ; }

    double GetDt() const { return m_dt ; }
    void SetDt(double value) { m_dt = value ; }

    wxString GetCustomCoord() const { return m_customCoord ; }
    void SetCustomCoord(wxString value) { m_customCoord = value ; }

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CVisualizationSettingsDlg member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin CVisualizationSettingsDlg member variables
    wxCalendarCtrl* m_dateEtCtrl;
    wxRadioButton* m_coordSolarCtrl;
    JakubSchwarzmeier::Astronomy::CDateTime m_timeEt;
    double m_dt;
    wxString m_customCoord;
////@end CVisualizationSettingsDlg member variables
};

#endif
    // _VISUALIZATIONSETTINGSDLG_H_
