/////////////////////////////////////////////////////////////////////////////
// Name:        mainframe.h
// Purpose:     
// Author:      Jakub Schwarzmeier
// Modified by: 
// Created:     08/11/06 10:11:05
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

#ifndef _MAINFRAME_H_
#define _MAINFRAME_H_

#if defined(__GNUG__) && !defined(__APPLE__)
#pragma interface "mainframe.cpp"
#endif

/*!
 * Includes
 */

////@begin includes
#include "wx/xrc/xmlres.h"
#include "wx/docmdi.h"
////@end includes

#include "ChildFrm.h"
#include "CamerasPanel.h"

/*!
 * Forward declarations
 */

////@begin forward declarations
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_MAINFRAME 10000
#define SYMBOL_CMAINFRAME_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxMINIMIZE_BOX|wxMAXIMIZE_BOX|wxCLOSE_BOX
#define SYMBOL_CMAINFRAME_TITLE _("Phaethon")
#define SYMBOL_CMAINFRAME_IDNAME ID_MAINFRAME
#define SYMBOL_CMAINFRAME_SIZE wxSize(400, 300)
#define SYMBOL_CMAINFRAME_POSITION wxDefaultPosition
////@end control identifiers

/*!
 * Compatibility
 */

#ifndef wxCLOSE_BOX
#define wxCLOSE_BOX 0x1000
#endif
#ifndef wxFIXED_MINSIZE
#define wxFIXED_MINSIZE 0
#endif

/*!
 * CMainFrame class declaration
 */

class CMainFrame: public wxDocMDIParentFrame
{    
    DECLARE_CLASS( wxDocMDIParentFrame )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CMainFrame( );
    CMainFrame( wxDocManager *manager, wxFrame *parent, wxWindowID id = SYMBOL_CMAINFRAME_IDNAME, const wxString& caption = SYMBOL_CMAINFRAME_TITLE, const wxPoint& pos = SYMBOL_CMAINFRAME_POSITION, const wxSize& size = SYMBOL_CMAINFRAME_SIZE, long style = SYMBOL_CMAINFRAME_STYLE );

    bool Create( wxDocManager *manager, wxFrame *parent, wxWindowID id = SYMBOL_CMAINFRAME_IDNAME, const wxString& caption = SYMBOL_CMAINFRAME_TITLE, const wxPoint& pos = SYMBOL_CMAINFRAME_POSITION, const wxSize& size = SYMBOL_CMAINFRAME_SIZE, long style = SYMBOL_CMAINFRAME_STYLE );

    /// Creates the controls and sizers
    void CreateControls();

////@begin CMainFrame event handler declarations

    /// wxEVT_CLOSE_WINDOW event handler for ID_MAINFRAME
    void OnFileExit( wxCloseEvent& event );

////@end CMainFrame event handler declarations

    void OnFileSettings( wxCommandEvent& event );

    void OnSimulationRunClick( wxCommandEvent& event );
    void OnSimulationBodiesClick( wxCommandEvent& event );
    void OnVisualizationAnimationClick( wxCommandEvent& event );
    void OnVisualizationSettingsClick( wxCommandEvent& event );

////@begin CMainFrame member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CMainFrame member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

    void OnSize(wxSizeEvent& event);

	CChildFrame * CreateChildFrame(wxDocument * pDocument, int pViewClass);
	void OnNewDocument();

////@begin CMainFrame member variables
////@end CMainFrame member variables

	void OnFileNew(wxCommandEvent& event);
	void OnFileOpen(wxCommandEvent& event);
	void OnFileClose(wxCommandEvent& event);
	void OnFileExit(wxCommandEvent& event);

	void OnClearTrajectories(wxCommandEvent& event);

	CCamerasPanel * m_camerasPanel;
    void OnMRUFile(wxCommandEvent& event);
};

#endif
    // _MAINFRAME_H_
